<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Clear' => '\\StructType\\Clear',
            'ClearResponse' => '\\StructType\\ClearResponse',
            'GetProcessStatus' => '\\StructType\\GetProcessStatus',
            'GetProcessStatusResponse' => '\\StructType\\GetProcessStatusResponse',
            'ProcessResult' => '\\StructType\\ProcessResult',
            'GetScenario' => '\\StructType\\GetScenario',
            'GetScenarioResponse' => '\\StructType\\GetScenarioResponse',
            'ArrayOfCommand' => '\\ArrayType\\ArrayOfCommand',
            'Command' => '\\StructType\\Command',
            'ElementDescriptor' => '\\StructType\\ElementDescriptor',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'Container' => '\\StructType\\Container',
            'ArrayOfField' => '\\ArrayType\\ArrayOfField',
            'Field' => '\\StructType\\Field',
            'Attachment' => '\\StructType\\Attachment',
            'Value' => '\\StructType\\Value',
            'ArrayOfContainer' => '\\ArrayType\\ArrayOfContainer',
            'EveryValue' => '\\StructType\\EveryValue',
            'Action' => '\\StructType\\Action',
            'Answer' => '\\StructType\\Answer',
            'RowNumber' => '\\StructType\\RowNumber',
            'NewRow' => '\\StructType\\NewRow',
            'Parameter' => '\\StructType\\Parameter',
            'Key' => '\\StructType\\Key',
            'DeleteRow' => '\\StructType\\DeleteRow',
            'GetSchema' => '\\StructType\\GetSchema',
            'GetSchemaResponse' => '\\StructType\\GetSchemaResponse',
            'Content' => '\\StructType\\Content',
            'SetSchema' => '\\StructType\\SetSchema',
            'SetSchemaResponse' => '\\StructType\\SetSchemaResponse',
            'Export' => '\\StructType\\Export',
            'ArrayOfFilter' => '\\ArrayType\\ArrayOfFilter',
            'Filter' => '\\StructType\\Filter',
            'ArrayOfArrayOfString' => '\\ArrayType\\ArrayOfArrayOfString',
            'ExportResponse' => '\\StructType\\ExportResponse',
            'Import' => '\\StructType\\Import',
            'ImportResult' => '\\StructType\\ImportResult',
            'ArrayOfValue' => '\\ArrayType\\ArrayOfValue',
            'ArrayOfImportResult' => '\\ArrayType\\ArrayOfImportResult',
            'ImportResponse' => '\\StructType\\ImportResponse',
            'Submit' => '\\StructType\\Submit',
            'ArrayOfContent' => '\\ArrayType\\ArrayOfContent',
            'SubmitResponse' => '\\StructType\\SubmitResponse',
            'Login' => '\\StructType\\Login',
            'LoginResult' => '\\StructType\\LoginResult',
            'LoginResponse' => '\\StructType\\LoginResponse',
            'Logout' => '\\StructType\\Logout',
            'LogoutResponse' => '\\StructType\\LogoutResponse',
            'SetBusinessDate' => '\\StructType\\SetBusinessDate',
            'SetBusinessDateResponse' => '\\StructType\\SetBusinessDateResponse',
            'SetLocaleName' => '\\StructType\\SetLocaleName',
            'SetLocaleNameResponse' => '\\StructType\\SetLocaleNameResponse',
            'SetSchemaMode' => '\\StructType\\SetSchemaMode',
            'SetSchemaModeResponse' => '\\StructType\\SetSchemaModeResponse',
            'PrimaryKey' => '\\StructType\\PrimaryKey',
            'Actions' => '\\StructType\\Actions',
            'OrderSummaryServiceCommands' => '\\StructType\\OrderSummaryServiceCommands',
            'OrderSummary' => '\\StructType\\OrderSummary',
            'CommissionsDefaultSalespersonServiceCommands' => '\\StructType\\CommissionsDefaultSalespersonServiceCommands',
            'CommissionsDefaultSalesperson' => '\\StructType\\CommissionsDefaultSalesperson',
            'FinancialSettingsFinancialInformationServiceCommands' => '\\StructType\\FinancialSettingsFinancialInformationServiceCommands',
            'FinancialSettingsFinancialInformation' => '\\StructType\\FinancialSettingsFinancialInformation',
            'PaymentSettingsServiceCommands' => '\\StructType\\PaymentSettingsServiceCommands',
            'PaymentSettings' => '\\StructType\\PaymentSettings',
            'ShippingSettingsShippingInformationServiceCommands' => '\\StructType\\ShippingSettingsShippingInformationServiceCommands',
            'ShippingSettingsShippingInformation' => '\\StructType\\ShippingSettingsShippingInformation',
            'DiscountDetailsDisableAutomaticDiscountUpdateServiceCommands' => '\\StructType\\DiscountDetailsDisableAutomaticDiscountUpdateServiceCommands',
            'DiscountDetailsDisableAutomaticDiscountUpdate' => '\\StructType\\DiscountDetailsDisableAutomaticDiscountUpdate',
            'TotalsOrderTotalsServiceCommands' => '\\StructType\\TotalsOrderTotalsServiceCommands',
            'TotalsOrderTotals' => '\\StructType\\TotalsOrderTotals',
            'TotalsFreightInfoServiceCommands' => '\\StructType\\TotalsFreightInfoServiceCommands',
            'TotalsFreightInfo' => '\\StructType\\TotalsFreightInfo',
            'TotalsCalculatedAmountsAndQuantitiesServiceCommands' => '\\StructType\\TotalsCalculatedAmountsAndQuantitiesServiceCommands',
            'TotalsCalculatedAmountsAndQuantities' => '\\StructType\\TotalsCalculatedAmountsAndQuantities',
            'ShopForRatesServicesSettingsServiceCommands' => '\\StructType\\ShopForRatesServicesSettingsServiceCommands',
            'ShopForRatesServicesSettings' => '\\StructType\\ShopForRatesServicesSettings',
            'ShopForRatesServicesSettingsIsManualPackageServiceCommands' => '\\StructType\\ShopForRatesServicesSettingsIsManualPackageServiceCommands',
            'ShopForRatesServicesSettingsIsManualPackage' => '\\StructType\\ShopForRatesServicesSettingsIsManualPackage',
            'ROTRUTDetailsRUTAndROTSettingsServiceCommands' => '\\StructType\\ROTRUTDetailsRUTAndROTSettingsServiceCommands',
            'ROTRUTDetailsRUTAndROTSettings' => '\\StructType\\ROTRUTDetailsRUTAndROTSettings',
            'ROTRUTDetailsRUTAndROTTotalsServiceCommands' => '\\StructType\\ROTRUTDetailsRUTAndROTTotalsServiceCommands',
            'ROTRUTDetailsRUTAndROTTotals' => '\\StructType\\ROTRUTDetailsRUTAndROTTotals',
            'DocumentDetailsServiceCommands' => '\\StructType\\DocumentDetailsServiceCommands',
            'DocumentDetails' => '\\StructType\\DocumentDetails',
            'PurchasingDetailsPurchasingSettingsServiceCommands' => '\\StructType\\PurchasingDetailsPurchasingSettingsServiceCommands',
            'PurchasingDetailsPurchasingSettings' => '\\StructType\\PurchasingDetailsPurchasingSettings',
            'TaxDetailsServiceCommands' => '\\StructType\\TaxDetailsServiceCommands',
            'TaxDetails' => '\\StructType\\TaxDetails',
            'ShipmentsServiceCommands' => '\\StructType\\ShipmentsServiceCommands',
            'Shipments' => '\\StructType\\Shipments',
            'FinancialSettingsBillToAddressServiceCommands' => '\\StructType\\FinancialSettingsBillToAddressServiceCommands',
            'FinancialSettingsBillToAddress' => '\\StructType\\FinancialSettingsBillToAddress',
            'ShippingSettingsShipToAddressServiceCommands' => '\\StructType\\ShippingSettingsShipToAddressServiceCommands',
            'ShippingSettingsShipToAddress' => '\\StructType\\ShippingSettingsShipToAddress',
            'FinancialSettingsBillToContactServiceCommands' => '\\StructType\\FinancialSettingsBillToContactServiceCommands',
            'FinancialSettingsBillToContact' => '\\StructType\\FinancialSettingsBillToContact',
            'ShippingSettingsShipToContactServiceCommands' => '\\StructType\\ShippingSettingsShipToContactServiceCommands',
            'ShippingSettingsShipToContact' => '\\StructType\\ShippingSettingsShipToContact',
            'ApprovalDetailsServiceCommands' => '\\StructType\\ApprovalDetailsServiceCommands',
            'ApprovalDetails' => '\\StructType\\ApprovalDetails',
            'OrderSummaryRateSelectionServiceCommands' => '\\StructType\\OrderSummaryRateSelectionServiceCommands',
            'OrderSummaryRateSelection' => '\\StructType\\OrderSummaryRateSelection',
            'OrderSummaryRateSelectionCurrencyUnitEquivalentsServiceCommands' => '\\StructType\\OrderSummaryRateSelectionCurrencyUnitEquivalentsServiceCommands',
            'OrderSummaryRateSelectionCurrencyUnitEquivalents' => '\\StructType\\OrderSummaryRateSelectionCurrencyUnitEquivalents',
            'DiscountDetailsServiceCommands' => '\\StructType\\DiscountDetailsServiceCommands',
            'DiscountDetails' => '\\StructType\\DiscountDetails',
            'AllocationsServiceCommands' => '\\StructType\\AllocationsServiceCommands',
            'Allocations' => '\\StructType\\Allocations',
            'SpecifyShipmentParametersServiceCommands' => '\\StructType\\SpecifyShipmentParametersServiceCommands',
            'SpecifyShipmentParameters' => '\\StructType\\SpecifyShipmentParameters',
            'AddInvoiceDetailsDocTypeServiceCommands' => '\\StructType\\AddInvoiceDetailsDocTypeServiceCommands',
            'AddInvoiceDetailsDocType' => '\\StructType\\AddInvoiceDetailsDocType',
            'CopyToServiceCommands' => '\\StructType\\CopyToServiceCommands',
            'CopyTo' => '\\StructType\\CopyTo',
            'RecalculatePricesServiceCommands' => '\\StructType\\RecalculatePricesServiceCommands',
            'RecalculatePrices' => '\\StructType\\RecalculatePrices',
            'AddInvoiceDetailsServiceCommands' => '\\StructType\\AddInvoiceDetailsServiceCommands',
            'AddInvoiceDetails' => '\\StructType\\AddInvoiceDetails',
            'PurchasingDetailsServiceCommands' => '\\StructType\\PurchasingDetailsServiceCommands',
            'PurchasingDetails' => '\\StructType\\PurchasingDetails',
            'CommissionsServiceCommands' => '\\StructType\\CommissionsServiceCommands',
            'Commissions' => '\\StructType\\Commissions',
            'ShopForRatesPackagesServiceCommands' => '\\StructType\\ShopForRatesPackagesServiceCommands',
            'ShopForRatesPackages' => '\\StructType\\ShopForRatesPackages',
            'PaymentsServiceCommands' => '\\StructType\\PaymentsServiceCommands',
            'Payments' => '\\StructType\\Payments',
            'ROTRUTDetailsRUTAndROTDistributionRUTAndROTDistributionServiceCommands' => '\\StructType\\ROTRUTDetailsRUTAndROTDistributionRUTAndROTDistributionServiceCommands',
            'ROTRUTDetailsRUTAndROTDistributionRUTAndROTDistribution' => '\\StructType\\ROTRUTDetailsRUTAndROTDistributionRUTAndROTDistribution',
            'PaymentSettingsInputModeServiceCommands' => '\\StructType\\PaymentSettingsInputModeServiceCommands',
            'PaymentSettingsInputMode' => '\\StructType\\PaymentSettingsInputMode',
            'PaymentSettingsCardInfoServiceCommands' => '\\StructType\\PaymentSettingsCardInfoServiceCommands',
            'PaymentSettingsCardInfo' => '\\StructType\\PaymentSettingsCardInfo',
            'PaymentSettingsDescriptionServiceCommands' => '\\StructType\\PaymentSettingsDescriptionServiceCommands',
            'PaymentSettingsDescription' => '\\StructType\\PaymentSettingsDescription',
            'InventoryLookupInventoryServiceCommands' => '\\StructType\\InventoryLookupInventoryServiceCommands',
            'InventoryLookupInventory' => '\\StructType\\InventoryLookupInventory',
            'InventoryLookupServiceCommands' => '\\StructType\\InventoryLookupServiceCommands',
            'InventoryLookup' => '\\StructType\\InventoryLookup',
            'ShopForRatesCarrierRatesServiceCommands' => '\\StructType\\ShopForRatesCarrierRatesServiceCommands',
            'ShopForRatesCarrierRates' => '\\StructType\\ShopForRatesCarrierRates',
            'CreateServiceOrderServiceCommands' => '\\StructType\\CreateServiceOrderServiceCommands',
            'CreateServiceOrder' => '\\StructType\\CreateServiceOrder',
            'AddMatrixItemMatrixViewAttributeValueServiceCommands' => '\\StructType\\AddMatrixItemMatrixViewAttributeValueServiceCommands',
            'AddMatrixItemMatrixViewAttributeValue' => '\\StructType\\AddMatrixItemMatrixViewAttributeValue',
            'ProcessOrderServiceCommands' => '\\StructType\\ProcessOrderServiceCommands',
            'ProcessOrder' => '\\StructType\\ProcessOrder',
            'ProcessOrderPrintingSettingsServiceCommands' => '\\StructType\\ProcessOrderPrintingSettingsServiceCommands',
            'ProcessOrderPrintingSettings' => '\\StructType\\ProcessOrderPrintingSettings',
            'ProcessOrderAvailabilityServiceCommands' => '\\StructType\\ProcessOrderAvailabilityServiceCommands',
            'ProcessOrderAvailability' => '\\StructType\\ProcessOrderAvailability',
            'ProcessOrderShippingServiceCommands' => '\\StructType\\ProcessOrderShippingServiceCommands',
            'ProcessOrderShipping' => '\\StructType\\ProcessOrderShipping',
            'ProcessOrderInvoicingServiceCommands' => '\\StructType\\ProcessOrderInvoicingServiceCommands',
            'ProcessOrderInvoicing' => '\\StructType\\ProcessOrderInvoicing',
            'EnterReasonServiceCommands' => '\\StructType\\EnterReasonServiceCommands',
            'EnterReason' => '\\StructType\\EnterReason',
            'AllocationsUnassignedQtyServiceCommands' => '\\StructType\\AllocationsUnassignedQtyServiceCommands',
            'AllocationsUnassignedQty' => '\\StructType\\AllocationsUnassignedQty',
            'AddMatrixItemTableViewTemplateItemIDServiceCommands' => '\\StructType\\AddMatrixItemTableViewTemplateItemIDServiceCommands',
            'AddMatrixItemTableViewTemplateItemID' => '\\StructType\\AddMatrixItemTableViewTemplateItemID',
            'AddMatrixItemMatrixViewServiceCommands' => '\\StructType\\AddMatrixItemMatrixViewServiceCommands',
            'AddMatrixItemMatrixView' => '\\StructType\\AddMatrixItemMatrixView',
            'AddMatrixItemMatrixViewTemplateItemServiceCommands' => '\\StructType\\AddMatrixItemMatrixViewTemplateItemServiceCommands',
            'AddMatrixItemMatrixViewTemplateItem' => '\\StructType\\AddMatrixItemMatrixViewTemplateItem',
            'AddMatrixItemTableViewServiceCommands' => '\\StructType\\AddMatrixItemTableViewServiceCommands',
            'AddMatrixItemTableView' => '\\StructType\\AddMatrixItemTableView',
        );
    }
}
