<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddInvoiceDetails StructType
 * @subpackage Structs
 */
class AddInvoiceDetails extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The Selected
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Selected;
    /**
     * The InventoryID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $InventoryID;
    /**
     * The Subitem
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Subitem;
    /**
     * The Warehouse
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Warehouse;
    /**
     * The Location
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Location;
    /**
     * The LotSerialNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $LotSerialNbr;
    /**
     * The UOM
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UOM;
    /**
     * The Quantity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Quantity;
    /**
     * The LineDescription
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $LineDescription;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AddInvoiceDetailsServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for AddInvoiceDetails
     * @uses AddInvoiceDetails::setDisplayName()
     * @uses AddInvoiceDetails::setSelected()
     * @uses AddInvoiceDetails::setInventoryID()
     * @uses AddInvoiceDetails::setSubitem()
     * @uses AddInvoiceDetails::setWarehouse()
     * @uses AddInvoiceDetails::setLocation()
     * @uses AddInvoiceDetails::setLotSerialNbr()
     * @uses AddInvoiceDetails::setUOM()
     * @uses AddInvoiceDetails::setQuantity()
     * @uses AddInvoiceDetails::setLineDescription()
     * @uses AddInvoiceDetails::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $selected
     * @param \StructType\Field $inventoryID
     * @param \StructType\Field $subitem
     * @param \StructType\Field $warehouse
     * @param \StructType\Field $location
     * @param \StructType\Field $lotSerialNbr
     * @param \StructType\Field $uOM
     * @param \StructType\Field $quantity
     * @param \StructType\Field $lineDescription
     * @param \StructType\AddInvoiceDetailsServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $selected = null, \StructType\Field $inventoryID = null, \StructType\Field $subitem = null, \StructType\Field $warehouse = null, \StructType\Field $location = null, \StructType\Field $lotSerialNbr = null, \StructType\Field $uOM = null, \StructType\Field $quantity = null, \StructType\Field $lineDescription = null, \StructType\AddInvoiceDetailsServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setSelected($selected)
            ->setInventoryID($inventoryID)
            ->setSubitem($subitem)
            ->setWarehouse($warehouse)
            ->setLocation($location)
            ->setLotSerialNbr($lotSerialNbr)
            ->setUOM($uOM)
            ->setQuantity($quantity)
            ->setLineDescription($lineDescription)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\AddInvoiceDetails
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get Selected value
     * @return \StructType\Field|null
     */
    public function getSelected()
    {
        return $this->Selected;
    }
    /**
     * Set Selected value
     * @param \StructType\Field $selected
     * @return \StructType\AddInvoiceDetails
     */
    public function setSelected(\StructType\Field $selected = null)
    {
        $this->Selected = $selected;
        return $this;
    }
    /**
     * Get InventoryID value
     * @return \StructType\Field|null
     */
    public function getInventoryID()
    {
        return $this->InventoryID;
    }
    /**
     * Set InventoryID value
     * @param \StructType\Field $inventoryID
     * @return \StructType\AddInvoiceDetails
     */
    public function setInventoryID(\StructType\Field $inventoryID = null)
    {
        $this->InventoryID = $inventoryID;
        return $this;
    }
    /**
     * Get Subitem value
     * @return \StructType\Field|null
     */
    public function getSubitem()
    {
        return $this->Subitem;
    }
    /**
     * Set Subitem value
     * @param \StructType\Field $subitem
     * @return \StructType\AddInvoiceDetails
     */
    public function setSubitem(\StructType\Field $subitem = null)
    {
        $this->Subitem = $subitem;
        return $this;
    }
    /**
     * Get Warehouse value
     * @return \StructType\Field|null
     */
    public function getWarehouse()
    {
        return $this->Warehouse;
    }
    /**
     * Set Warehouse value
     * @param \StructType\Field $warehouse
     * @return \StructType\AddInvoiceDetails
     */
    public function setWarehouse(\StructType\Field $warehouse = null)
    {
        $this->Warehouse = $warehouse;
        return $this;
    }
    /**
     * Get Location value
     * @return \StructType\Field|null
     */
    public function getLocation()
    {
        return $this->Location;
    }
    /**
     * Set Location value
     * @param \StructType\Field $location
     * @return \StructType\AddInvoiceDetails
     */
    public function setLocation(\StructType\Field $location = null)
    {
        $this->Location = $location;
        return $this;
    }
    /**
     * Get LotSerialNbr value
     * @return \StructType\Field|null
     */
    public function getLotSerialNbr()
    {
        return $this->LotSerialNbr;
    }
    /**
     * Set LotSerialNbr value
     * @param \StructType\Field $lotSerialNbr
     * @return \StructType\AddInvoiceDetails
     */
    public function setLotSerialNbr(\StructType\Field $lotSerialNbr = null)
    {
        $this->LotSerialNbr = $lotSerialNbr;
        return $this;
    }
    /**
     * Get UOM value
     * @return \StructType\Field|null
     */
    public function getUOM()
    {
        return $this->UOM;
    }
    /**
     * Set UOM value
     * @param \StructType\Field $uOM
     * @return \StructType\AddInvoiceDetails
     */
    public function setUOM(\StructType\Field $uOM = null)
    {
        $this->UOM = $uOM;
        return $this;
    }
    /**
     * Get Quantity value
     * @return \StructType\Field|null
     */
    public function getQuantity()
    {
        return $this->Quantity;
    }
    /**
     * Set Quantity value
     * @param \StructType\Field $quantity
     * @return \StructType\AddInvoiceDetails
     */
    public function setQuantity(\StructType\Field $quantity = null)
    {
        $this->Quantity = $quantity;
        return $this;
    }
    /**
     * Get LineDescription value
     * @return \StructType\Field|null
     */
    public function getLineDescription()
    {
        return $this->LineDescription;
    }
    /**
     * Set LineDescription value
     * @param \StructType\Field $lineDescription
     * @return \StructType\AddInvoiceDetails
     */
    public function setLineDescription(\StructType\Field $lineDescription = null)
    {
        $this->LineDescription = $lineDescription;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\AddInvoiceDetailsServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\AddInvoiceDetailsServiceCommands $serviceCommands
     * @return \StructType\AddInvoiceDetails
     */
    public function setServiceCommands(\StructType\AddInvoiceDetailsServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddInvoiceDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
