<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddInvoiceDetailsDocType StructType
 * @subpackage Structs
 */
class AddInvoiceDetailsDocType extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The DocType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DocType;
    /**
     * The RefNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $RefNbr;
    /**
     * The Expand
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Expand;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AddInvoiceDetailsDocTypeServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for AddInvoiceDetailsDocType
     * @uses AddInvoiceDetailsDocType::setDisplayName()
     * @uses AddInvoiceDetailsDocType::setDocType()
     * @uses AddInvoiceDetailsDocType::setRefNbr()
     * @uses AddInvoiceDetailsDocType::setExpand()
     * @uses AddInvoiceDetailsDocType::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $docType
     * @param \StructType\Field $refNbr
     * @param \StructType\Field $expand
     * @param \StructType\AddInvoiceDetailsDocTypeServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $docType = null, \StructType\Field $refNbr = null, \StructType\Field $expand = null, \StructType\AddInvoiceDetailsDocTypeServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setDocType($docType)
            ->setRefNbr($refNbr)
            ->setExpand($expand)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\AddInvoiceDetailsDocType
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get DocType value
     * @return \StructType\Field|null
     */
    public function getDocType()
    {
        return $this->DocType;
    }
    /**
     * Set DocType value
     * @param \StructType\Field $docType
     * @return \StructType\AddInvoiceDetailsDocType
     */
    public function setDocType(\StructType\Field $docType = null)
    {
        $this->DocType = $docType;
        return $this;
    }
    /**
     * Get RefNbr value
     * @return \StructType\Field|null
     */
    public function getRefNbr()
    {
        return $this->RefNbr;
    }
    /**
     * Set RefNbr value
     * @param \StructType\Field $refNbr
     * @return \StructType\AddInvoiceDetailsDocType
     */
    public function setRefNbr(\StructType\Field $refNbr = null)
    {
        $this->RefNbr = $refNbr;
        return $this;
    }
    /**
     * Get Expand value
     * @return \StructType\Field|null
     */
    public function getExpand()
    {
        return $this->Expand;
    }
    /**
     * Set Expand value
     * @param \StructType\Field $expand
     * @return \StructType\AddInvoiceDetailsDocType
     */
    public function setExpand(\StructType\Field $expand = null)
    {
        $this->Expand = $expand;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\AddInvoiceDetailsDocTypeServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\AddInvoiceDetailsDocTypeServiceCommands $serviceCommands
     * @return \StructType\AddInvoiceDetailsDocType
     */
    public function setServiceCommands(\StructType\AddInvoiceDetailsDocTypeServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddInvoiceDetailsDocType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
