<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddMatrixItemMatrixViewAttributeValue StructType
 * @subpackage Structs
 */
class AddMatrixItemMatrixViewAttributeValue extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The AttributeValue
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $AttributeValue;
    /**
     * The MatrixAvailability
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $MatrixAvailability;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AddMatrixItemMatrixViewAttributeValueServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for AddMatrixItemMatrixViewAttributeValue
     * @uses AddMatrixItemMatrixViewAttributeValue::setDisplayName()
     * @uses AddMatrixItemMatrixViewAttributeValue::setAttributeValue()
     * @uses AddMatrixItemMatrixViewAttributeValue::setMatrixAvailability()
     * @uses AddMatrixItemMatrixViewAttributeValue::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $attributeValue
     * @param \StructType\Field $matrixAvailability
     * @param \StructType\AddMatrixItemMatrixViewAttributeValueServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $attributeValue = null, \StructType\Field $matrixAvailability = null, \StructType\AddMatrixItemMatrixViewAttributeValueServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setAttributeValue($attributeValue)
            ->setMatrixAvailability($matrixAvailability)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\AddMatrixItemMatrixViewAttributeValue
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get AttributeValue value
     * @return \StructType\Field|null
     */
    public function getAttributeValue()
    {
        return $this->AttributeValue;
    }
    /**
     * Set AttributeValue value
     * @param \StructType\Field $attributeValue
     * @return \StructType\AddMatrixItemMatrixViewAttributeValue
     */
    public function setAttributeValue(\StructType\Field $attributeValue = null)
    {
        $this->AttributeValue = $attributeValue;
        return $this;
    }
    /**
     * Get MatrixAvailability value
     * @return \StructType\Field|null
     */
    public function getMatrixAvailability()
    {
        return $this->MatrixAvailability;
    }
    /**
     * Set MatrixAvailability value
     * @param \StructType\Field $matrixAvailability
     * @return \StructType\AddMatrixItemMatrixViewAttributeValue
     */
    public function setMatrixAvailability(\StructType\Field $matrixAvailability = null)
    {
        $this->MatrixAvailability = $matrixAvailability;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\AddMatrixItemMatrixViewAttributeValueServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\AddMatrixItemMatrixViewAttributeValueServiceCommands $serviceCommands
     * @return \StructType\AddMatrixItemMatrixViewAttributeValue
     */
    public function setServiceCommands(\StructType\AddMatrixItemMatrixViewAttributeValueServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddMatrixItemMatrixViewAttributeValue
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
