<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddMatrixItemMatrixViewTemplateItem StructType
 * @subpackage Structs
 */
class AddMatrixItemMatrixViewTemplateItem extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The TemplateItem
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TemplateItem;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AddMatrixItemMatrixViewTemplateItemServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for AddMatrixItemMatrixViewTemplateItem
     * @uses AddMatrixItemMatrixViewTemplateItem::setDisplayName()
     * @uses AddMatrixItemMatrixViewTemplateItem::setTemplateItem()
     * @uses AddMatrixItemMatrixViewTemplateItem::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $templateItem
     * @param \StructType\AddMatrixItemMatrixViewTemplateItemServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $templateItem = null, \StructType\AddMatrixItemMatrixViewTemplateItemServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setTemplateItem($templateItem)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\AddMatrixItemMatrixViewTemplateItem
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get TemplateItem value
     * @return \StructType\Field|null
     */
    public function getTemplateItem()
    {
        return $this->TemplateItem;
    }
    /**
     * Set TemplateItem value
     * @param \StructType\Field $templateItem
     * @return \StructType\AddMatrixItemMatrixViewTemplateItem
     */
    public function setTemplateItem(\StructType\Field $templateItem = null)
    {
        $this->TemplateItem = $templateItem;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\AddMatrixItemMatrixViewTemplateItemServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\AddMatrixItemMatrixViewTemplateItemServiceCommands $serviceCommands
     * @return \StructType\AddMatrixItemMatrixViewTemplateItem
     */
    public function setServiceCommands(\StructType\AddMatrixItemMatrixViewTemplateItemServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddMatrixItemMatrixViewTemplateItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
