<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddMatrixItemTableView StructType
 * @subpackage Structs
 */
class AddMatrixItemTableView extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The Quantity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Quantity;
    /**
     * The InventoryID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $InventoryID;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Description;
    /**
     * The New
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $New;
    /**
     * The AttributeValue0
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $AttributeValue0;
    /**
     * The StockItem
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $StockItem;
    /**
     * The DefaultPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DefaultPrice;
    /**
     * The ItemClass
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ItemClass;
    /**
     * The TaxCategory
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TaxCategory;
    /**
     * The NoteText
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $NoteText;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AddMatrixItemTableViewServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for AddMatrixItemTableView
     * @uses AddMatrixItemTableView::setDisplayName()
     * @uses AddMatrixItemTableView::setQuantity()
     * @uses AddMatrixItemTableView::setInventoryID()
     * @uses AddMatrixItemTableView::setDescription()
     * @uses AddMatrixItemTableView::setNew()
     * @uses AddMatrixItemTableView::setAttributeValue0()
     * @uses AddMatrixItemTableView::setStockItem()
     * @uses AddMatrixItemTableView::setDefaultPrice()
     * @uses AddMatrixItemTableView::setItemClass()
     * @uses AddMatrixItemTableView::setTaxCategory()
     * @uses AddMatrixItemTableView::setNoteText()
     * @uses AddMatrixItemTableView::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $quantity
     * @param \StructType\Field $inventoryID
     * @param \StructType\Field $description
     * @param \StructType\Field $new
     * @param \StructType\Field $attributeValue0
     * @param \StructType\Field $stockItem
     * @param \StructType\Field $defaultPrice
     * @param \StructType\Field $itemClass
     * @param \StructType\Field $taxCategory
     * @param \StructType\Field $noteText
     * @param \StructType\AddMatrixItemTableViewServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $quantity = null, \StructType\Field $inventoryID = null, \StructType\Field $description = null, \StructType\Field $new = null, \StructType\Field $attributeValue0 = null, \StructType\Field $stockItem = null, \StructType\Field $defaultPrice = null, \StructType\Field $itemClass = null, \StructType\Field $taxCategory = null, \StructType\Field $noteText = null, \StructType\AddMatrixItemTableViewServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setQuantity($quantity)
            ->setInventoryID($inventoryID)
            ->setDescription($description)
            ->setNew($new)
            ->setAttributeValue0($attributeValue0)
            ->setStockItem($stockItem)
            ->setDefaultPrice($defaultPrice)
            ->setItemClass($itemClass)
            ->setTaxCategory($taxCategory)
            ->setNoteText($noteText)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\AddMatrixItemTableView
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get Quantity value
     * @return \StructType\Field|null
     */
    public function getQuantity()
    {
        return $this->Quantity;
    }
    /**
     * Set Quantity value
     * @param \StructType\Field $quantity
     * @return \StructType\AddMatrixItemTableView
     */
    public function setQuantity(\StructType\Field $quantity = null)
    {
        $this->Quantity = $quantity;
        return $this;
    }
    /**
     * Get InventoryID value
     * @return \StructType\Field|null
     */
    public function getInventoryID()
    {
        return $this->InventoryID;
    }
    /**
     * Set InventoryID value
     * @param \StructType\Field $inventoryID
     * @return \StructType\AddMatrixItemTableView
     */
    public function setInventoryID(\StructType\Field $inventoryID = null)
    {
        $this->InventoryID = $inventoryID;
        return $this;
    }
    /**
     * Get Description value
     * @return \StructType\Field|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param \StructType\Field $description
     * @return \StructType\AddMatrixItemTableView
     */
    public function setDescription(\StructType\Field $description = null)
    {
        $this->Description = $description;
        return $this;
    }
    /**
     * Get New value
     * @return \StructType\Field|null
     */
    public function getNew()
    {
        return $this->New;
    }
    /**
     * Set New value
     * @param \StructType\Field $new
     * @return \StructType\AddMatrixItemTableView
     */
    public function setNew(\StructType\Field $new = null)
    {
        $this->New = $new;
        return $this;
    }
    /**
     * Get AttributeValue0 value
     * @return \StructType\Field|null
     */
    public function getAttributeValue0()
    {
        return $this->AttributeValue0;
    }
    /**
     * Set AttributeValue0 value
     * @param \StructType\Field $attributeValue0
     * @return \StructType\AddMatrixItemTableView
     */
    public function setAttributeValue0(\StructType\Field $attributeValue0 = null)
    {
        $this->AttributeValue0 = $attributeValue0;
        return $this;
    }
    /**
     * Get StockItem value
     * @return \StructType\Field|null
     */
    public function getStockItem()
    {
        return $this->StockItem;
    }
    /**
     * Set StockItem value
     * @param \StructType\Field $stockItem
     * @return \StructType\AddMatrixItemTableView
     */
    public function setStockItem(\StructType\Field $stockItem = null)
    {
        $this->StockItem = $stockItem;
        return $this;
    }
    /**
     * Get DefaultPrice value
     * @return \StructType\Field|null
     */
    public function getDefaultPrice()
    {
        return $this->DefaultPrice;
    }
    /**
     * Set DefaultPrice value
     * @param \StructType\Field $defaultPrice
     * @return \StructType\AddMatrixItemTableView
     */
    public function setDefaultPrice(\StructType\Field $defaultPrice = null)
    {
        $this->DefaultPrice = $defaultPrice;
        return $this;
    }
    /**
     * Get ItemClass value
     * @return \StructType\Field|null
     */
    public function getItemClass()
    {
        return $this->ItemClass;
    }
    /**
     * Set ItemClass value
     * @param \StructType\Field $itemClass
     * @return \StructType\AddMatrixItemTableView
     */
    public function setItemClass(\StructType\Field $itemClass = null)
    {
        $this->ItemClass = $itemClass;
        return $this;
    }
    /**
     * Get TaxCategory value
     * @return \StructType\Field|null
     */
    public function getTaxCategory()
    {
        return $this->TaxCategory;
    }
    /**
     * Set TaxCategory value
     * @param \StructType\Field $taxCategory
     * @return \StructType\AddMatrixItemTableView
     */
    public function setTaxCategory(\StructType\Field $taxCategory = null)
    {
        $this->TaxCategory = $taxCategory;
        return $this;
    }
    /**
     * Get NoteText value
     * @return \StructType\Field|null
     */
    public function getNoteText()
    {
        return $this->NoteText;
    }
    /**
     * Set NoteText value
     * @param \StructType\Field $noteText
     * @return \StructType\AddMatrixItemTableView
     */
    public function setNoteText(\StructType\Field $noteText = null)
    {
        $this->NoteText = $noteText;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\AddMatrixItemTableViewServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\AddMatrixItemTableViewServiceCommands $serviceCommands
     * @return \StructType\AddMatrixItemTableView
     */
    public function setServiceCommands(\StructType\AddMatrixItemTableViewServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddMatrixItemTableView
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
