<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddMatrixItemTableViewTemplateItemID StructType
 * @subpackage Structs
 */
class AddMatrixItemTableViewTemplateItemID extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The TemplateItemID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TemplateItemID;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Description;
    /**
     * The SiteID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $SiteID;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AddMatrixItemTableViewTemplateItemIDServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for AddMatrixItemTableViewTemplateItemID
     * @uses AddMatrixItemTableViewTemplateItemID::setDisplayName()
     * @uses AddMatrixItemTableViewTemplateItemID::setTemplateItemID()
     * @uses AddMatrixItemTableViewTemplateItemID::setDescription()
     * @uses AddMatrixItemTableViewTemplateItemID::setSiteID()
     * @uses AddMatrixItemTableViewTemplateItemID::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $templateItemID
     * @param \StructType\Field $description
     * @param \StructType\Field $siteID
     * @param \StructType\AddMatrixItemTableViewTemplateItemIDServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $templateItemID = null, \StructType\Field $description = null, \StructType\Field $siteID = null, \StructType\AddMatrixItemTableViewTemplateItemIDServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setTemplateItemID($templateItemID)
            ->setDescription($description)
            ->setSiteID($siteID)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\AddMatrixItemTableViewTemplateItemID
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get TemplateItemID value
     * @return \StructType\Field|null
     */
    public function getTemplateItemID()
    {
        return $this->TemplateItemID;
    }
    /**
     * Set TemplateItemID value
     * @param \StructType\Field $templateItemID
     * @return \StructType\AddMatrixItemTableViewTemplateItemID
     */
    public function setTemplateItemID(\StructType\Field $templateItemID = null)
    {
        $this->TemplateItemID = $templateItemID;
        return $this;
    }
    /**
     * Get Description value
     * @return \StructType\Field|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param \StructType\Field $description
     * @return \StructType\AddMatrixItemTableViewTemplateItemID
     */
    public function setDescription(\StructType\Field $description = null)
    {
        $this->Description = $description;
        return $this;
    }
    /**
     * Get SiteID value
     * @return \StructType\Field|null
     */
    public function getSiteID()
    {
        return $this->SiteID;
    }
    /**
     * Set SiteID value
     * @param \StructType\Field $siteID
     * @return \StructType\AddMatrixItemTableViewTemplateItemID
     */
    public function setSiteID(\StructType\Field $siteID = null)
    {
        $this->SiteID = $siteID;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\AddMatrixItemTableViewTemplateItemIDServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\AddMatrixItemTableViewTemplateItemIDServiceCommands $serviceCommands
     * @return \StructType\AddMatrixItemTableViewTemplateItemID
     */
    public function setServiceCommands(\StructType\AddMatrixItemTableViewTemplateItemIDServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddMatrixItemTableViewTemplateItemID
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
