<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CommissionsDefaultSalesperson StructType
 * @subpackage Structs
 */
class CommissionsDefaultSalesperson extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The DefaultSalesperson
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DefaultSalesperson;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CommissionsDefaultSalespersonServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for CommissionsDefaultSalesperson
     * @uses CommissionsDefaultSalesperson::setDisplayName()
     * @uses CommissionsDefaultSalesperson::setDefaultSalesperson()
     * @uses CommissionsDefaultSalesperson::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $defaultSalesperson
     * @param \StructType\CommissionsDefaultSalespersonServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $defaultSalesperson = null, \StructType\CommissionsDefaultSalespersonServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setDefaultSalesperson($defaultSalesperson)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\CommissionsDefaultSalesperson
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get DefaultSalesperson value
     * @return \StructType\Field|null
     */
    public function getDefaultSalesperson()
    {
        return $this->DefaultSalesperson;
    }
    /**
     * Set DefaultSalesperson value
     * @param \StructType\Field $defaultSalesperson
     * @return \StructType\CommissionsDefaultSalesperson
     */
    public function setDefaultSalesperson(\StructType\Field $defaultSalesperson = null)
    {
        $this->DefaultSalesperson = $defaultSalesperson;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\CommissionsDefaultSalespersonServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\CommissionsDefaultSalespersonServiceCommands $serviceCommands
     * @return \StructType\CommissionsDefaultSalesperson
     */
    public function setServiceCommands(\StructType\CommissionsDefaultSalespersonServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CommissionsDefaultSalesperson
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
