<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateServiceOrder StructType
 * @subpackage Structs
 */
class CreateServiceOrder extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The SrvOrdType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $SrvOrdType;
    /**
     * The AssignedEmpID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $AssignedEmpID;
    /**
     * The SLAETADate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $SLAETADate;
    /**
     * The SLAETATime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $SLAETATime;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CreateServiceOrderServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for CreateServiceOrder
     * @uses CreateServiceOrder::setDisplayName()
     * @uses CreateServiceOrder::setSrvOrdType()
     * @uses CreateServiceOrder::setAssignedEmpID()
     * @uses CreateServiceOrder::setSLAETADate()
     * @uses CreateServiceOrder::setSLAETATime()
     * @uses CreateServiceOrder::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $srvOrdType
     * @param \StructType\Field $assignedEmpID
     * @param \StructType\Field $sLAETADate
     * @param \StructType\Field $sLAETATime
     * @param \StructType\CreateServiceOrderServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $srvOrdType = null, \StructType\Field $assignedEmpID = null, \StructType\Field $sLAETADate = null, \StructType\Field $sLAETATime = null, \StructType\CreateServiceOrderServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setSrvOrdType($srvOrdType)
            ->setAssignedEmpID($assignedEmpID)
            ->setSLAETADate($sLAETADate)
            ->setSLAETATime($sLAETATime)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\CreateServiceOrder
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get SrvOrdType value
     * @return \StructType\Field|null
     */
    public function getSrvOrdType()
    {
        return $this->SrvOrdType;
    }
    /**
     * Set SrvOrdType value
     * @param \StructType\Field $srvOrdType
     * @return \StructType\CreateServiceOrder
     */
    public function setSrvOrdType(\StructType\Field $srvOrdType = null)
    {
        $this->SrvOrdType = $srvOrdType;
        return $this;
    }
    /**
     * Get AssignedEmpID value
     * @return \StructType\Field|null
     */
    public function getAssignedEmpID()
    {
        return $this->AssignedEmpID;
    }
    /**
     * Set AssignedEmpID value
     * @param \StructType\Field $assignedEmpID
     * @return \StructType\CreateServiceOrder
     */
    public function setAssignedEmpID(\StructType\Field $assignedEmpID = null)
    {
        $this->AssignedEmpID = $assignedEmpID;
        return $this;
    }
    /**
     * Get SLAETADate value
     * @return \StructType\Field|null
     */
    public function getSLAETADate()
    {
        return $this->SLAETADate;
    }
    /**
     * Set SLAETADate value
     * @param \StructType\Field $sLAETADate
     * @return \StructType\CreateServiceOrder
     */
    public function setSLAETADate(\StructType\Field $sLAETADate = null)
    {
        $this->SLAETADate = $sLAETADate;
        return $this;
    }
    /**
     * Get SLAETATime value
     * @return \StructType\Field|null
     */
    public function getSLAETATime()
    {
        return $this->SLAETATime;
    }
    /**
     * Set SLAETATime value
     * @param \StructType\Field $sLAETATime
     * @return \StructType\CreateServiceOrder
     */
    public function setSLAETATime(\StructType\Field $sLAETATime = null)
    {
        $this->SLAETATime = $sLAETATime;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\CreateServiceOrderServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\CreateServiceOrderServiceCommands $serviceCommands
     * @return \StructType\CreateServiceOrder
     */
    public function setServiceCommands(\StructType\CreateServiceOrderServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateServiceOrder
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
