<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InventoryLookupInventory StructType
 * @subpackage Structs
 */
class InventoryLookupInventory extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The Inventory
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Inventory;
    /**
     * The BarCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $BarCode;
    /**
     * The SiteID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $SiteID;
    /**
     * The ItemClass
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ItemClass;
    /**
     * The SubItem
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $SubItem;
    /**
     * The Mode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Mode;
    /**
     * The OnlyAvailable
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OnlyAvailable;
    /**
     * The DropShipSales
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DropShipSales;
    /**
     * The HistoryDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $HistoryDate;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\InventoryLookupInventoryServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for InventoryLookupInventory
     * @uses InventoryLookupInventory::setDisplayName()
     * @uses InventoryLookupInventory::setInventory()
     * @uses InventoryLookupInventory::setBarCode()
     * @uses InventoryLookupInventory::setSiteID()
     * @uses InventoryLookupInventory::setItemClass()
     * @uses InventoryLookupInventory::setSubItem()
     * @uses InventoryLookupInventory::setMode()
     * @uses InventoryLookupInventory::setOnlyAvailable()
     * @uses InventoryLookupInventory::setDropShipSales()
     * @uses InventoryLookupInventory::setHistoryDate()
     * @uses InventoryLookupInventory::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $inventory
     * @param \StructType\Field $barCode
     * @param \StructType\Field $siteID
     * @param \StructType\Field $itemClass
     * @param \StructType\Field $subItem
     * @param \StructType\Field $mode
     * @param \StructType\Field $onlyAvailable
     * @param \StructType\Field $dropShipSales
     * @param \StructType\Field $historyDate
     * @param \StructType\InventoryLookupInventoryServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $inventory = null, \StructType\Field $barCode = null, \StructType\Field $siteID = null, \StructType\Field $itemClass = null, \StructType\Field $subItem = null, \StructType\Field $mode = null, \StructType\Field $onlyAvailable = null, \StructType\Field $dropShipSales = null, \StructType\Field $historyDate = null, \StructType\InventoryLookupInventoryServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setInventory($inventory)
            ->setBarCode($barCode)
            ->setSiteID($siteID)
            ->setItemClass($itemClass)
            ->setSubItem($subItem)
            ->setMode($mode)
            ->setOnlyAvailable($onlyAvailable)
            ->setDropShipSales($dropShipSales)
            ->setHistoryDate($historyDate)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\InventoryLookupInventory
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get Inventory value
     * @return \StructType\Field|null
     */
    public function getInventory()
    {
        return $this->Inventory;
    }
    /**
     * Set Inventory value
     * @param \StructType\Field $inventory
     * @return \StructType\InventoryLookupInventory
     */
    public function setInventory(\StructType\Field $inventory = null)
    {
        $this->Inventory = $inventory;
        return $this;
    }
    /**
     * Get BarCode value
     * @return \StructType\Field|null
     */
    public function getBarCode()
    {
        return $this->BarCode;
    }
    /**
     * Set BarCode value
     * @param \StructType\Field $barCode
     * @return \StructType\InventoryLookupInventory
     */
    public function setBarCode(\StructType\Field $barCode = null)
    {
        $this->BarCode = $barCode;
        return $this;
    }
    /**
     * Get SiteID value
     * @return \StructType\Field|null
     */
    public function getSiteID()
    {
        return $this->SiteID;
    }
    /**
     * Set SiteID value
     * @param \StructType\Field $siteID
     * @return \StructType\InventoryLookupInventory
     */
    public function setSiteID(\StructType\Field $siteID = null)
    {
        $this->SiteID = $siteID;
        return $this;
    }
    /**
     * Get ItemClass value
     * @return \StructType\Field|null
     */
    public function getItemClass()
    {
        return $this->ItemClass;
    }
    /**
     * Set ItemClass value
     * @param \StructType\Field $itemClass
     * @return \StructType\InventoryLookupInventory
     */
    public function setItemClass(\StructType\Field $itemClass = null)
    {
        $this->ItemClass = $itemClass;
        return $this;
    }
    /**
     * Get SubItem value
     * @return \StructType\Field|null
     */
    public function getSubItem()
    {
        return $this->SubItem;
    }
    /**
     * Set SubItem value
     * @param \StructType\Field $subItem
     * @return \StructType\InventoryLookupInventory
     */
    public function setSubItem(\StructType\Field $subItem = null)
    {
        $this->SubItem = $subItem;
        return $this;
    }
    /**
     * Get Mode value
     * @return \StructType\Field|null
     */
    public function getMode()
    {
        return $this->Mode;
    }
    /**
     * Set Mode value
     * @param \StructType\Field $mode
     * @return \StructType\InventoryLookupInventory
     */
    public function setMode(\StructType\Field $mode = null)
    {
        $this->Mode = $mode;
        return $this;
    }
    /**
     * Get OnlyAvailable value
     * @return \StructType\Field|null
     */
    public function getOnlyAvailable()
    {
        return $this->OnlyAvailable;
    }
    /**
     * Set OnlyAvailable value
     * @param \StructType\Field $onlyAvailable
     * @return \StructType\InventoryLookupInventory
     */
    public function setOnlyAvailable(\StructType\Field $onlyAvailable = null)
    {
        $this->OnlyAvailable = $onlyAvailable;
        return $this;
    }
    /**
     * Get DropShipSales value
     * @return \StructType\Field|null
     */
    public function getDropShipSales()
    {
        return $this->DropShipSales;
    }
    /**
     * Set DropShipSales value
     * @param \StructType\Field $dropShipSales
     * @return \StructType\InventoryLookupInventory
     */
    public function setDropShipSales(\StructType\Field $dropShipSales = null)
    {
        $this->DropShipSales = $dropShipSales;
        return $this;
    }
    /**
     * Get HistoryDate value
     * @return \StructType\Field|null
     */
    public function getHistoryDate()
    {
        return $this->HistoryDate;
    }
    /**
     * Set HistoryDate value
     * @param \StructType\Field $historyDate
     * @return \StructType\InventoryLookupInventory
     */
    public function setHistoryDate(\StructType\Field $historyDate = null)
    {
        $this->HistoryDate = $historyDate;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\InventoryLookupInventoryServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\InventoryLookupInventoryServiceCommands $serviceCommands
     * @return \StructType\InventoryLookupInventory
     */
    public function setServiceCommands(\StructType\InventoryLookupInventoryServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InventoryLookupInventory
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
