<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderSummaryServiceCommands StructType
 * @subpackage Structs
 */
class OrderSummaryServiceCommands extends AbstractStructBase
{
    /**
     * The KeyOrderType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Key
     */
    public $KeyOrderType;
    /**
     * The EveryOrderType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\EveryValue
     */
    public $EveryOrderType;
    /**
     * The KeyOrderNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Key
     */
    public $KeyOrderNbr;
    /**
     * The EveryOrderNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\EveryValue
     */
    public $EveryOrderNbr;
    /**
     * The DeleteRow
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DeleteRow
     */
    public $DeleteRow;
    /**
     * The DialogAnswer
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Answer
     */
    public $DialogAnswer;
    /**
     * The Attachment
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Attachment
     */
    public $Attachment;
    /**
     * Constructor method for OrderSummaryServiceCommands
     * @uses OrderSummaryServiceCommands::setKeyOrderType()
     * @uses OrderSummaryServiceCommands::setEveryOrderType()
     * @uses OrderSummaryServiceCommands::setKeyOrderNbr()
     * @uses OrderSummaryServiceCommands::setEveryOrderNbr()
     * @uses OrderSummaryServiceCommands::setDeleteRow()
     * @uses OrderSummaryServiceCommands::setDialogAnswer()
     * @uses OrderSummaryServiceCommands::setAttachment()
     * @param \StructType\Key $keyOrderType
     * @param \StructType\EveryValue $everyOrderType
     * @param \StructType\Key $keyOrderNbr
     * @param \StructType\EveryValue $everyOrderNbr
     * @param \StructType\DeleteRow $deleteRow
     * @param \StructType\Answer $dialogAnswer
     * @param \StructType\Attachment $attachment
     */
    public function __construct(\StructType\Key $keyOrderType = null, \StructType\EveryValue $everyOrderType = null, \StructType\Key $keyOrderNbr = null, \StructType\EveryValue $everyOrderNbr = null, \StructType\DeleteRow $deleteRow = null, \StructType\Answer $dialogAnswer = null, \StructType\Attachment $attachment = null)
    {
        $this
            ->setKeyOrderType($keyOrderType)
            ->setEveryOrderType($everyOrderType)
            ->setKeyOrderNbr($keyOrderNbr)
            ->setEveryOrderNbr($everyOrderNbr)
            ->setDeleteRow($deleteRow)
            ->setDialogAnswer($dialogAnswer)
            ->setAttachment($attachment);
    }
    /**
     * Get KeyOrderType value
     * @return \StructType\Key|null
     */
    public function getKeyOrderType()
    {
        return $this->KeyOrderType;
    }
    /**
     * Set KeyOrderType value
     * @param \StructType\Key $keyOrderType
     * @return \StructType\OrderSummaryServiceCommands
     */
    public function setKeyOrderType(\StructType\Key $keyOrderType = null)
    {
        $this->KeyOrderType = $keyOrderType;
        return $this;
    }
    /**
     * Get EveryOrderType value
     * @return \StructType\EveryValue|null
     */
    public function getEveryOrderType()
    {
        return $this->EveryOrderType;
    }
    /**
     * Set EveryOrderType value
     * @param \StructType\EveryValue $everyOrderType
     * @return \StructType\OrderSummaryServiceCommands
     */
    public function setEveryOrderType(\StructType\EveryValue $everyOrderType = null)
    {
        $this->EveryOrderType = $everyOrderType;
        return $this;
    }
    /**
     * Get KeyOrderNbr value
     * @return \StructType\Key|null
     */
    public function getKeyOrderNbr()
    {
        return $this->KeyOrderNbr;
    }
    /**
     * Set KeyOrderNbr value
     * @param \StructType\Key $keyOrderNbr
     * @return \StructType\OrderSummaryServiceCommands
     */
    public function setKeyOrderNbr(\StructType\Key $keyOrderNbr = null)
    {
        $this->KeyOrderNbr = $keyOrderNbr;
        return $this;
    }
    /**
     * Get EveryOrderNbr value
     * @return \StructType\EveryValue|null
     */
    public function getEveryOrderNbr()
    {
        return $this->EveryOrderNbr;
    }
    /**
     * Set EveryOrderNbr value
     * @param \StructType\EveryValue $everyOrderNbr
     * @return \StructType\OrderSummaryServiceCommands
     */
    public function setEveryOrderNbr(\StructType\EveryValue $everyOrderNbr = null)
    {
        $this->EveryOrderNbr = $everyOrderNbr;
        return $this;
    }
    /**
     * Get DeleteRow value
     * @return \StructType\DeleteRow|null
     */
    public function getDeleteRow()
    {
        return $this->DeleteRow;
    }
    /**
     * Set DeleteRow value
     * @param \StructType\DeleteRow $deleteRow
     * @return \StructType\OrderSummaryServiceCommands
     */
    public function setDeleteRow(\StructType\DeleteRow $deleteRow = null)
    {
        $this->DeleteRow = $deleteRow;
        return $this;
    }
    /**
     * Get DialogAnswer value
     * @return \StructType\Answer|null
     */
    public function getDialogAnswer()
    {
        return $this->DialogAnswer;
    }
    /**
     * Set DialogAnswer value
     * @param \StructType\Answer $dialogAnswer
     * @return \StructType\OrderSummaryServiceCommands
     */
    public function setDialogAnswer(\StructType\Answer $dialogAnswer = null)
    {
        $this->DialogAnswer = $dialogAnswer;
        return $this;
    }
    /**
     * Get Attachment value
     * @return \StructType\Attachment|null
     */
    public function getAttachment()
    {
        return $this->Attachment;
    }
    /**
     * Set Attachment value
     * @param \StructType\Attachment $attachment
     * @return \StructType\OrderSummaryServiceCommands
     */
    public function setAttachment(\StructType\Attachment $attachment = null)
    {
        $this->Attachment = $attachment;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OrderSummaryServiceCommands
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
