<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PaymentSettingsCardInfo StructType
 * @subpackage Structs
 */
class PaymentSettingsCardInfo extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The ProcCenterID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ProcCenterID;
    /**
     * The Identifier
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Identifier;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PaymentSettingsCardInfoServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for PaymentSettingsCardInfo
     * @uses PaymentSettingsCardInfo::setDisplayName()
     * @uses PaymentSettingsCardInfo::setProcCenterID()
     * @uses PaymentSettingsCardInfo::setIdentifier()
     * @uses PaymentSettingsCardInfo::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $procCenterID
     * @param \StructType\Field $identifier
     * @param \StructType\PaymentSettingsCardInfoServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $procCenterID = null, \StructType\Field $identifier = null, \StructType\PaymentSettingsCardInfoServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setProcCenterID($procCenterID)
            ->setIdentifier($identifier)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\PaymentSettingsCardInfo
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get ProcCenterID value
     * @return \StructType\Field|null
     */
    public function getProcCenterID()
    {
        return $this->ProcCenterID;
    }
    /**
     * Set ProcCenterID value
     * @param \StructType\Field $procCenterID
     * @return \StructType\PaymentSettingsCardInfo
     */
    public function setProcCenterID(\StructType\Field $procCenterID = null)
    {
        $this->ProcCenterID = $procCenterID;
        return $this;
    }
    /**
     * Get Identifier value
     * @return \StructType\Field|null
     */
    public function getIdentifier()
    {
        return $this->Identifier;
    }
    /**
     * Set Identifier value
     * @param \StructType\Field $identifier
     * @return \StructType\PaymentSettingsCardInfo
     */
    public function setIdentifier(\StructType\Field $identifier = null)
    {
        $this->Identifier = $identifier;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\PaymentSettingsCardInfoServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\PaymentSettingsCardInfoServiceCommands $serviceCommands
     * @return \StructType\PaymentSettingsCardInfo
     */
    public function setServiceCommands(\StructType\PaymentSettingsCardInfoServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PaymentSettingsCardInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
