<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PaymentSettingsDescriptionServiceCommands StructType
 * @subpackage Structs
 */
class PaymentSettingsDescriptionServiceCommands extends AbstractStructBase
{
    /**
     * The KeyDescription
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Key
     */
    public $KeyDescription;
    /**
     * The NewRow
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\NewRow
     */
    public $NewRow;
    /**
     * The RowNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RowNumber
     */
    public $RowNumber;
    /**
     * The DeleteRow
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DeleteRow
     */
    public $DeleteRow;
    /**
     * The DialogAnswer
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Answer
     */
    public $DialogAnswer;
    /**
     * Constructor method for PaymentSettingsDescriptionServiceCommands
     * @uses PaymentSettingsDescriptionServiceCommands::setKeyDescription()
     * @uses PaymentSettingsDescriptionServiceCommands::setNewRow()
     * @uses PaymentSettingsDescriptionServiceCommands::setRowNumber()
     * @uses PaymentSettingsDescriptionServiceCommands::setDeleteRow()
     * @uses PaymentSettingsDescriptionServiceCommands::setDialogAnswer()
     * @param \StructType\Key $keyDescription
     * @param \StructType\NewRow $newRow
     * @param \StructType\RowNumber $rowNumber
     * @param \StructType\DeleteRow $deleteRow
     * @param \StructType\Answer $dialogAnswer
     */
    public function __construct(\StructType\Key $keyDescription = null, \StructType\NewRow $newRow = null, \StructType\RowNumber $rowNumber = null, \StructType\DeleteRow $deleteRow = null, \StructType\Answer $dialogAnswer = null)
    {
        $this
            ->setKeyDescription($keyDescription)
            ->setNewRow($newRow)
            ->setRowNumber($rowNumber)
            ->setDeleteRow($deleteRow)
            ->setDialogAnswer($dialogAnswer);
    }
    /**
     * Get KeyDescription value
     * @return \StructType\Key|null
     */
    public function getKeyDescription()
    {
        return $this->KeyDescription;
    }
    /**
     * Set KeyDescription value
     * @param \StructType\Key $keyDescription
     * @return \StructType\PaymentSettingsDescriptionServiceCommands
     */
    public function setKeyDescription(\StructType\Key $keyDescription = null)
    {
        $this->KeyDescription = $keyDescription;
        return $this;
    }
    /**
     * Get NewRow value
     * @return \StructType\NewRow|null
     */
    public function getNewRow()
    {
        return $this->NewRow;
    }
    /**
     * Set NewRow value
     * @param \StructType\NewRow $newRow
     * @return \StructType\PaymentSettingsDescriptionServiceCommands
     */
    public function setNewRow(\StructType\NewRow $newRow = null)
    {
        $this->NewRow = $newRow;
        return $this;
    }
    /**
     * Get RowNumber value
     * @return \StructType\RowNumber|null
     */
    public function getRowNumber()
    {
        return $this->RowNumber;
    }
    /**
     * Set RowNumber value
     * @param \StructType\RowNumber $rowNumber
     * @return \StructType\PaymentSettingsDescriptionServiceCommands
     */
    public function setRowNumber(\StructType\RowNumber $rowNumber = null)
    {
        $this->RowNumber = $rowNumber;
        return $this;
    }
    /**
     * Get DeleteRow value
     * @return \StructType\DeleteRow|null
     */
    public function getDeleteRow()
    {
        return $this->DeleteRow;
    }
    /**
     * Set DeleteRow value
     * @param \StructType\DeleteRow $deleteRow
     * @return \StructType\PaymentSettingsDescriptionServiceCommands
     */
    public function setDeleteRow(\StructType\DeleteRow $deleteRow = null)
    {
        $this->DeleteRow = $deleteRow;
        return $this;
    }
    /**
     * Get DialogAnswer value
     * @return \StructType\Answer|null
     */
    public function getDialogAnswer()
    {
        return $this->DialogAnswer;
    }
    /**
     * Set DialogAnswer value
     * @param \StructType\Answer $dialogAnswer
     * @return \StructType\PaymentSettingsDescriptionServiceCommands
     */
    public function setDialogAnswer(\StructType\Answer $dialogAnswer = null)
    {
        $this->DialogAnswer = $dialogAnswer;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PaymentSettingsDescriptionServiceCommands
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
