<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PaymentSettingsInputMode StructType
 * @subpackage Structs
 */
class PaymentSettingsInputMode extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The InputMode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $InputMode;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PaymentSettingsInputModeServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for PaymentSettingsInputMode
     * @uses PaymentSettingsInputMode::setDisplayName()
     * @uses PaymentSettingsInputMode::setInputMode()
     * @uses PaymentSettingsInputMode::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $inputMode
     * @param \StructType\PaymentSettingsInputModeServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $inputMode = null, \StructType\PaymentSettingsInputModeServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setInputMode($inputMode)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\PaymentSettingsInputMode
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get InputMode value
     * @return \StructType\Field|null
     */
    public function getInputMode()
    {
        return $this->InputMode;
    }
    /**
     * Set InputMode value
     * @param \StructType\Field $inputMode
     * @return \StructType\PaymentSettingsInputMode
     */
    public function setInputMode(\StructType\Field $inputMode = null)
    {
        $this->InputMode = $inputMode;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\PaymentSettingsInputModeServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\PaymentSettingsInputModeServiceCommands $serviceCommands
     * @return \StructType\PaymentSettingsInputMode
     */
    public function setServiceCommands(\StructType\PaymentSettingsInputModeServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PaymentSettingsInputMode
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
