<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Payments StructType
 * @subpackage Structs
 */
class Payments extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The DocType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DocType;
    /**
     * The ReferenceNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ReferenceNbr;
    /**
     * The AppliedToOrder
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $AppliedToOrder;
    /**
     * The TransferredToInvoice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TransferredToInvoice;
    /**
     * The Balance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Balance;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Status;
    /**
     * The PaymentRef
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PaymentRef;
    /**
     * The PaymentMethod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PaymentMethod;
    /**
     * The CashAccount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CashAccount;
    /**
     * The PaymentAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PaymentAmount;
    /**
     * The Currency
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Currency;
    /**
     * The NoteText
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $NoteText;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PaymentsServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for Payments
     * @uses Payments::setDisplayName()
     * @uses Payments::setDocType()
     * @uses Payments::setReferenceNbr()
     * @uses Payments::setAppliedToOrder()
     * @uses Payments::setTransferredToInvoice()
     * @uses Payments::setBalance()
     * @uses Payments::setStatus()
     * @uses Payments::setPaymentRef()
     * @uses Payments::setPaymentMethod()
     * @uses Payments::setCashAccount()
     * @uses Payments::setPaymentAmount()
     * @uses Payments::setCurrency()
     * @uses Payments::setNoteText()
     * @uses Payments::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $docType
     * @param \StructType\Field $referenceNbr
     * @param \StructType\Field $appliedToOrder
     * @param \StructType\Field $transferredToInvoice
     * @param \StructType\Field $balance
     * @param \StructType\Field $status
     * @param \StructType\Field $paymentRef
     * @param \StructType\Field $paymentMethod
     * @param \StructType\Field $cashAccount
     * @param \StructType\Field $paymentAmount
     * @param \StructType\Field $currency
     * @param \StructType\Field $noteText
     * @param \StructType\PaymentsServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $docType = null, \StructType\Field $referenceNbr = null, \StructType\Field $appliedToOrder = null, \StructType\Field $transferredToInvoice = null, \StructType\Field $balance = null, \StructType\Field $status = null, \StructType\Field $paymentRef = null, \StructType\Field $paymentMethod = null, \StructType\Field $cashAccount = null, \StructType\Field $paymentAmount = null, \StructType\Field $currency = null, \StructType\Field $noteText = null, \StructType\PaymentsServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setDocType($docType)
            ->setReferenceNbr($referenceNbr)
            ->setAppliedToOrder($appliedToOrder)
            ->setTransferredToInvoice($transferredToInvoice)
            ->setBalance($balance)
            ->setStatus($status)
            ->setPaymentRef($paymentRef)
            ->setPaymentMethod($paymentMethod)
            ->setCashAccount($cashAccount)
            ->setPaymentAmount($paymentAmount)
            ->setCurrency($currency)
            ->setNoteText($noteText)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\Payments
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get DocType value
     * @return \StructType\Field|null
     */
    public function getDocType()
    {
        return $this->DocType;
    }
    /**
     * Set DocType value
     * @param \StructType\Field $docType
     * @return \StructType\Payments
     */
    public function setDocType(\StructType\Field $docType = null)
    {
        $this->DocType = $docType;
        return $this;
    }
    /**
     * Get ReferenceNbr value
     * @return \StructType\Field|null
     */
    public function getReferenceNbr()
    {
        return $this->ReferenceNbr;
    }
    /**
     * Set ReferenceNbr value
     * @param \StructType\Field $referenceNbr
     * @return \StructType\Payments
     */
    public function setReferenceNbr(\StructType\Field $referenceNbr = null)
    {
        $this->ReferenceNbr = $referenceNbr;
        return $this;
    }
    /**
     * Get AppliedToOrder value
     * @return \StructType\Field|null
     */
    public function getAppliedToOrder()
    {
        return $this->AppliedToOrder;
    }
    /**
     * Set AppliedToOrder value
     * @param \StructType\Field $appliedToOrder
     * @return \StructType\Payments
     */
    public function setAppliedToOrder(\StructType\Field $appliedToOrder = null)
    {
        $this->AppliedToOrder = $appliedToOrder;
        return $this;
    }
    /**
     * Get TransferredToInvoice value
     * @return \StructType\Field|null
     */
    public function getTransferredToInvoice()
    {
        return $this->TransferredToInvoice;
    }
    /**
     * Set TransferredToInvoice value
     * @param \StructType\Field $transferredToInvoice
     * @return \StructType\Payments
     */
    public function setTransferredToInvoice(\StructType\Field $transferredToInvoice = null)
    {
        $this->TransferredToInvoice = $transferredToInvoice;
        return $this;
    }
    /**
     * Get Balance value
     * @return \StructType\Field|null
     */
    public function getBalance()
    {
        return $this->Balance;
    }
    /**
     * Set Balance value
     * @param \StructType\Field $balance
     * @return \StructType\Payments
     */
    public function setBalance(\StructType\Field $balance = null)
    {
        $this->Balance = $balance;
        return $this;
    }
    /**
     * Get Status value
     * @return \StructType\Field|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param \StructType\Field $status
     * @return \StructType\Payments
     */
    public function setStatus(\StructType\Field $status = null)
    {
        $this->Status = $status;
        return $this;
    }
    /**
     * Get PaymentRef value
     * @return \StructType\Field|null
     */
    public function getPaymentRef()
    {
        return $this->PaymentRef;
    }
    /**
     * Set PaymentRef value
     * @param \StructType\Field $paymentRef
     * @return \StructType\Payments
     */
    public function setPaymentRef(\StructType\Field $paymentRef = null)
    {
        $this->PaymentRef = $paymentRef;
        return $this;
    }
    /**
     * Get PaymentMethod value
     * @return \StructType\Field|null
     */
    public function getPaymentMethod()
    {
        return $this->PaymentMethod;
    }
    /**
     * Set PaymentMethod value
     * @param \StructType\Field $paymentMethod
     * @return \StructType\Payments
     */
    public function setPaymentMethod(\StructType\Field $paymentMethod = null)
    {
        $this->PaymentMethod = $paymentMethod;
        return $this;
    }
    /**
     * Get CashAccount value
     * @return \StructType\Field|null
     */
    public function getCashAccount()
    {
        return $this->CashAccount;
    }
    /**
     * Set CashAccount value
     * @param \StructType\Field $cashAccount
     * @return \StructType\Payments
     */
    public function setCashAccount(\StructType\Field $cashAccount = null)
    {
        $this->CashAccount = $cashAccount;
        return $this;
    }
    /**
     * Get PaymentAmount value
     * @return \StructType\Field|null
     */
    public function getPaymentAmount()
    {
        return $this->PaymentAmount;
    }
    /**
     * Set PaymentAmount value
     * @param \StructType\Field $paymentAmount
     * @return \StructType\Payments
     */
    public function setPaymentAmount(\StructType\Field $paymentAmount = null)
    {
        $this->PaymentAmount = $paymentAmount;
        return $this;
    }
    /**
     * Get Currency value
     * @return \StructType\Field|null
     */
    public function getCurrency()
    {
        return $this->Currency;
    }
    /**
     * Set Currency value
     * @param \StructType\Field $currency
     * @return \StructType\Payments
     */
    public function setCurrency(\StructType\Field $currency = null)
    {
        $this->Currency = $currency;
        return $this;
    }
    /**
     * Get NoteText value
     * @return \StructType\Field|null
     */
    public function getNoteText()
    {
        return $this->NoteText;
    }
    /**
     * Set NoteText value
     * @param \StructType\Field $noteText
     * @return \StructType\Payments
     */
    public function setNoteText(\StructType\Field $noteText = null)
    {
        $this->NoteText = $noteText;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\PaymentsServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\PaymentsServiceCommands $serviceCommands
     * @return \StructType\Payments
     */
    public function setServiceCommands(\StructType\PaymentsServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Payments
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
