<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProcessOrderPrintingSettings StructType
 * @subpackage Structs
 */
class ProcessOrderPrintingSettings extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The PrintWithDeviceHub
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PrintWithDeviceHub;
    /**
     * The DefinePrintersManually
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DefinePrintersManually;
    /**
     * The Printer
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Printer;
    /**
     * The PrinterPrinter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PrinterPrinter;
    /**
     * The NumberOfCopies
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $NumberOfCopies;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ProcessOrderPrintingSettingsServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for ProcessOrderPrintingSettings
     * @uses ProcessOrderPrintingSettings::setDisplayName()
     * @uses ProcessOrderPrintingSettings::setPrintWithDeviceHub()
     * @uses ProcessOrderPrintingSettings::setDefinePrintersManually()
     * @uses ProcessOrderPrintingSettings::setPrinter()
     * @uses ProcessOrderPrintingSettings::setPrinterPrinter()
     * @uses ProcessOrderPrintingSettings::setNumberOfCopies()
     * @uses ProcessOrderPrintingSettings::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $printWithDeviceHub
     * @param \StructType\Field $definePrintersManually
     * @param \StructType\Field $printer
     * @param \StructType\Field $printerPrinter
     * @param \StructType\Field $numberOfCopies
     * @param \StructType\ProcessOrderPrintingSettingsServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $printWithDeviceHub = null, \StructType\Field $definePrintersManually = null, \StructType\Field $printer = null, \StructType\Field $printerPrinter = null, \StructType\Field $numberOfCopies = null, \StructType\ProcessOrderPrintingSettingsServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setPrintWithDeviceHub($printWithDeviceHub)
            ->setDefinePrintersManually($definePrintersManually)
            ->setPrinter($printer)
            ->setPrinterPrinter($printerPrinter)
            ->setNumberOfCopies($numberOfCopies)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\ProcessOrderPrintingSettings
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get PrintWithDeviceHub value
     * @return \StructType\Field|null
     */
    public function getPrintWithDeviceHub()
    {
        return $this->PrintWithDeviceHub;
    }
    /**
     * Set PrintWithDeviceHub value
     * @param \StructType\Field $printWithDeviceHub
     * @return \StructType\ProcessOrderPrintingSettings
     */
    public function setPrintWithDeviceHub(\StructType\Field $printWithDeviceHub = null)
    {
        $this->PrintWithDeviceHub = $printWithDeviceHub;
        return $this;
    }
    /**
     * Get DefinePrintersManually value
     * @return \StructType\Field|null
     */
    public function getDefinePrintersManually()
    {
        return $this->DefinePrintersManually;
    }
    /**
     * Set DefinePrintersManually value
     * @param \StructType\Field $definePrintersManually
     * @return \StructType\ProcessOrderPrintingSettings
     */
    public function setDefinePrintersManually(\StructType\Field $definePrintersManually = null)
    {
        $this->DefinePrintersManually = $definePrintersManually;
        return $this;
    }
    /**
     * Get Printer value
     * @return \StructType\Field|null
     */
    public function getPrinter()
    {
        return $this->Printer;
    }
    /**
     * Set Printer value
     * @param \StructType\Field $printer
     * @return \StructType\ProcessOrderPrintingSettings
     */
    public function setPrinter(\StructType\Field $printer = null)
    {
        $this->Printer = $printer;
        return $this;
    }
    /**
     * Get PrinterPrinter value
     * @return \StructType\Field|null
     */
    public function getPrinterPrinter()
    {
        return $this->PrinterPrinter;
    }
    /**
     * Set PrinterPrinter value
     * @param \StructType\Field $printerPrinter
     * @return \StructType\ProcessOrderPrintingSettings
     */
    public function setPrinterPrinter(\StructType\Field $printerPrinter = null)
    {
        $this->PrinterPrinter = $printerPrinter;
        return $this;
    }
    /**
     * Get NumberOfCopies value
     * @return \StructType\Field|null
     */
    public function getNumberOfCopies()
    {
        return $this->NumberOfCopies;
    }
    /**
     * Set NumberOfCopies value
     * @param \StructType\Field $numberOfCopies
     * @return \StructType\ProcessOrderPrintingSettings
     */
    public function setNumberOfCopies(\StructType\Field $numberOfCopies = null)
    {
        $this->NumberOfCopies = $numberOfCopies;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\ProcessOrderPrintingSettingsServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\ProcessOrderPrintingSettingsServiceCommands $serviceCommands
     * @return \StructType\ProcessOrderPrintingSettings
     */
    public function setServiceCommands(\StructType\ProcessOrderPrintingSettingsServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ProcessOrderPrintingSettings
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
