<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ROTRUTDetailsRUTAndROTSettings StructType
 * @subpackage Structs
 */
class ROTRUTDetailsRUTAndROTSettings extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The DistributeAutomatically
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DistributeAutomatically;
    /**
     * The DeductionType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DeductionType;
    /**
     * The Apartment
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Apartment;
    /**
     * The RealEstate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $RealEstate;
    /**
     * The OrganizationNbr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OrganizationNbr;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ROTRUTDetailsRUTAndROTSettingsServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for ROTRUTDetailsRUTAndROTSettings
     * @uses ROTRUTDetailsRUTAndROTSettings::setDisplayName()
     * @uses ROTRUTDetailsRUTAndROTSettings::setDistributeAutomatically()
     * @uses ROTRUTDetailsRUTAndROTSettings::setDeductionType()
     * @uses ROTRUTDetailsRUTAndROTSettings::setApartment()
     * @uses ROTRUTDetailsRUTAndROTSettings::setRealEstate()
     * @uses ROTRUTDetailsRUTAndROTSettings::setOrganizationNbr()
     * @uses ROTRUTDetailsRUTAndROTSettings::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $distributeAutomatically
     * @param \StructType\Field $deductionType
     * @param \StructType\Field $apartment
     * @param \StructType\Field $realEstate
     * @param \StructType\Field $organizationNbr
     * @param \StructType\ROTRUTDetailsRUTAndROTSettingsServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $distributeAutomatically = null, \StructType\Field $deductionType = null, \StructType\Field $apartment = null, \StructType\Field $realEstate = null, \StructType\Field $organizationNbr = null, \StructType\ROTRUTDetailsRUTAndROTSettingsServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setDistributeAutomatically($distributeAutomatically)
            ->setDeductionType($deductionType)
            ->setApartment($apartment)
            ->setRealEstate($realEstate)
            ->setOrganizationNbr($organizationNbr)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\ROTRUTDetailsRUTAndROTSettings
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get DistributeAutomatically value
     * @return \StructType\Field|null
     */
    public function getDistributeAutomatically()
    {
        return $this->DistributeAutomatically;
    }
    /**
     * Set DistributeAutomatically value
     * @param \StructType\Field $distributeAutomatically
     * @return \StructType\ROTRUTDetailsRUTAndROTSettings
     */
    public function setDistributeAutomatically(\StructType\Field $distributeAutomatically = null)
    {
        $this->DistributeAutomatically = $distributeAutomatically;
        return $this;
    }
    /**
     * Get DeductionType value
     * @return \StructType\Field|null
     */
    public function getDeductionType()
    {
        return $this->DeductionType;
    }
    /**
     * Set DeductionType value
     * @param \StructType\Field $deductionType
     * @return \StructType\ROTRUTDetailsRUTAndROTSettings
     */
    public function setDeductionType(\StructType\Field $deductionType = null)
    {
        $this->DeductionType = $deductionType;
        return $this;
    }
    /**
     * Get Apartment value
     * @return \StructType\Field|null
     */
    public function getApartment()
    {
        return $this->Apartment;
    }
    /**
     * Set Apartment value
     * @param \StructType\Field $apartment
     * @return \StructType\ROTRUTDetailsRUTAndROTSettings
     */
    public function setApartment(\StructType\Field $apartment = null)
    {
        $this->Apartment = $apartment;
        return $this;
    }
    /**
     * Get RealEstate value
     * @return \StructType\Field|null
     */
    public function getRealEstate()
    {
        return $this->RealEstate;
    }
    /**
     * Set RealEstate value
     * @param \StructType\Field $realEstate
     * @return \StructType\ROTRUTDetailsRUTAndROTSettings
     */
    public function setRealEstate(\StructType\Field $realEstate = null)
    {
        $this->RealEstate = $realEstate;
        return $this;
    }
    /**
     * Get OrganizationNbr value
     * @return \StructType\Field|null
     */
    public function getOrganizationNbr()
    {
        return $this->OrganizationNbr;
    }
    /**
     * Set OrganizationNbr value
     * @param \StructType\Field $organizationNbr
     * @return \StructType\ROTRUTDetailsRUTAndROTSettings
     */
    public function setOrganizationNbr(\StructType\Field $organizationNbr = null)
    {
        $this->OrganizationNbr = $organizationNbr;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\ROTRUTDetailsRUTAndROTSettingsServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\ROTRUTDetailsRUTAndROTSettingsServiceCommands $serviceCommands
     * @return \StructType\ROTRUTDetailsRUTAndROTSettings
     */
    public function setServiceCommands(\StructType\ROTRUTDetailsRUTAndROTSettingsServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ROTRUTDetailsRUTAndROTSettings
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
