<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ROTRUTDetailsRUTAndROTTotals StructType
 * @subpackage Structs
 */
class ROTRUTDetailsRUTAndROTTotals extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The Deduction
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Deduction;
    /**
     * The TotalDeductibleAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TotalDeductibleAmount;
    /**
     * The OtherCost
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OtherCost;
    /**
     * The MaterialCost
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $MaterialCost;
    /**
     * The WorkPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $WorkPrice;
    /**
     * The DistributedAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $DistributedAmount;
    /**
     * The UndistributedAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UndistributedAmount;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ROTRUTDetailsRUTAndROTTotalsServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for ROTRUTDetailsRUTAndROTTotals
     * @uses ROTRUTDetailsRUTAndROTTotals::setDisplayName()
     * @uses ROTRUTDetailsRUTAndROTTotals::setDeduction()
     * @uses ROTRUTDetailsRUTAndROTTotals::setTotalDeductibleAmount()
     * @uses ROTRUTDetailsRUTAndROTTotals::setOtherCost()
     * @uses ROTRUTDetailsRUTAndROTTotals::setMaterialCost()
     * @uses ROTRUTDetailsRUTAndROTTotals::setWorkPrice()
     * @uses ROTRUTDetailsRUTAndROTTotals::setDistributedAmount()
     * @uses ROTRUTDetailsRUTAndROTTotals::setUndistributedAmount()
     * @uses ROTRUTDetailsRUTAndROTTotals::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $deduction
     * @param \StructType\Field $totalDeductibleAmount
     * @param \StructType\Field $otherCost
     * @param \StructType\Field $materialCost
     * @param \StructType\Field $workPrice
     * @param \StructType\Field $distributedAmount
     * @param \StructType\Field $undistributedAmount
     * @param \StructType\ROTRUTDetailsRUTAndROTTotalsServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $deduction = null, \StructType\Field $totalDeductibleAmount = null, \StructType\Field $otherCost = null, \StructType\Field $materialCost = null, \StructType\Field $workPrice = null, \StructType\Field $distributedAmount = null, \StructType\Field $undistributedAmount = null, \StructType\ROTRUTDetailsRUTAndROTTotalsServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setDeduction($deduction)
            ->setTotalDeductibleAmount($totalDeductibleAmount)
            ->setOtherCost($otherCost)
            ->setMaterialCost($materialCost)
            ->setWorkPrice($workPrice)
            ->setDistributedAmount($distributedAmount)
            ->setUndistributedAmount($undistributedAmount)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\ROTRUTDetailsRUTAndROTTotals
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get Deduction value
     * @return \StructType\Field|null
     */
    public function getDeduction()
    {
        return $this->Deduction;
    }
    /**
     * Set Deduction value
     * @param \StructType\Field $deduction
     * @return \StructType\ROTRUTDetailsRUTAndROTTotals
     */
    public function setDeduction(\StructType\Field $deduction = null)
    {
        $this->Deduction = $deduction;
        return $this;
    }
    /**
     * Get TotalDeductibleAmount value
     * @return \StructType\Field|null
     */
    public function getTotalDeductibleAmount()
    {
        return $this->TotalDeductibleAmount;
    }
    /**
     * Set TotalDeductibleAmount value
     * @param \StructType\Field $totalDeductibleAmount
     * @return \StructType\ROTRUTDetailsRUTAndROTTotals
     */
    public function setTotalDeductibleAmount(\StructType\Field $totalDeductibleAmount = null)
    {
        $this->TotalDeductibleAmount = $totalDeductibleAmount;
        return $this;
    }
    /**
     * Get OtherCost value
     * @return \StructType\Field|null
     */
    public function getOtherCost()
    {
        return $this->OtherCost;
    }
    /**
     * Set OtherCost value
     * @param \StructType\Field $otherCost
     * @return \StructType\ROTRUTDetailsRUTAndROTTotals
     */
    public function setOtherCost(\StructType\Field $otherCost = null)
    {
        $this->OtherCost = $otherCost;
        return $this;
    }
    /**
     * Get MaterialCost value
     * @return \StructType\Field|null
     */
    public function getMaterialCost()
    {
        return $this->MaterialCost;
    }
    /**
     * Set MaterialCost value
     * @param \StructType\Field $materialCost
     * @return \StructType\ROTRUTDetailsRUTAndROTTotals
     */
    public function setMaterialCost(\StructType\Field $materialCost = null)
    {
        $this->MaterialCost = $materialCost;
        return $this;
    }
    /**
     * Get WorkPrice value
     * @return \StructType\Field|null
     */
    public function getWorkPrice()
    {
        return $this->WorkPrice;
    }
    /**
     * Set WorkPrice value
     * @param \StructType\Field $workPrice
     * @return \StructType\ROTRUTDetailsRUTAndROTTotals
     */
    public function setWorkPrice(\StructType\Field $workPrice = null)
    {
        $this->WorkPrice = $workPrice;
        return $this;
    }
    /**
     * Get DistributedAmount value
     * @return \StructType\Field|null
     */
    public function getDistributedAmount()
    {
        return $this->DistributedAmount;
    }
    /**
     * Set DistributedAmount value
     * @param \StructType\Field $distributedAmount
     * @return \StructType\ROTRUTDetailsRUTAndROTTotals
     */
    public function setDistributedAmount(\StructType\Field $distributedAmount = null)
    {
        $this->DistributedAmount = $distributedAmount;
        return $this;
    }
    /**
     * Get UndistributedAmount value
     * @return \StructType\Field|null
     */
    public function getUndistributedAmount()
    {
        return $this->UndistributedAmount;
    }
    /**
     * Set UndistributedAmount value
     * @param \StructType\Field $undistributedAmount
     * @return \StructType\ROTRUTDetailsRUTAndROTTotals
     */
    public function setUndistributedAmount(\StructType\Field $undistributedAmount = null)
    {
        $this->UndistributedAmount = $undistributedAmount;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\ROTRUTDetailsRUTAndROTTotalsServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\ROTRUTDetailsRUTAndROTTotalsServiceCommands $serviceCommands
     * @return \StructType\ROTRUTDetailsRUTAndROTTotals
     */
    public function setServiceCommands(\StructType\ROTRUTDetailsRUTAndROTTotalsServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ROTRUTDetailsRUTAndROTTotals
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
