<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetLocaleName StructType
 * @subpackage Structs
 */
class SetLocaleName extends AbstractStructBase
{
    /**
     * The localeName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $localeName;
    /**
     * Constructor method for SetLocaleName
     * @uses SetLocaleName::setLocaleName()
     * @param string $localeName
     */
    public function __construct($localeName = null)
    {
        $this
            ->setLocaleName($localeName);
    }
    /**
     * Get localeName value
     * @return string|null
     */
    public function getLocaleName()
    {
        return $this->localeName;
    }
    /**
     * Set localeName value
     * @param string $localeName
     * @return \StructType\SetLocaleName
     */
    public function setLocaleName($localeName = null)
    {
        // validation for constraint: string
        if (!is_null($localeName) && !is_string($localeName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($localeName, true), gettype($localeName)), __LINE__);
        }
        $this->localeName = $localeName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetLocaleName
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
