<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShippingSettingsShipToContact StructType
 * @subpackage Structs
 */
class ShippingSettingsShipToContact extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The OverrideContact
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $OverrideContact;
    /**
     * The CompanyName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $CompanyName;
    /**
     * The Attention
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Attention;
    /**
     * The Phone1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Phone1;
    /**
     * The Email
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $Email;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ShippingSettingsShipToContactServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for ShippingSettingsShipToContact
     * @uses ShippingSettingsShipToContact::setDisplayName()
     * @uses ShippingSettingsShipToContact::setOverrideContact()
     * @uses ShippingSettingsShipToContact::setCompanyName()
     * @uses ShippingSettingsShipToContact::setAttention()
     * @uses ShippingSettingsShipToContact::setPhone1()
     * @uses ShippingSettingsShipToContact::setEmail()
     * @uses ShippingSettingsShipToContact::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $overrideContact
     * @param \StructType\Field $companyName
     * @param \StructType\Field $attention
     * @param \StructType\Field $phone1
     * @param \StructType\Field $email
     * @param \StructType\ShippingSettingsShipToContactServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $overrideContact = null, \StructType\Field $companyName = null, \StructType\Field $attention = null, \StructType\Field $phone1 = null, \StructType\Field $email = null, \StructType\ShippingSettingsShipToContactServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setOverrideContact($overrideContact)
            ->setCompanyName($companyName)
            ->setAttention($attention)
            ->setPhone1($phone1)
            ->setEmail($email)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\ShippingSettingsShipToContact
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get OverrideContact value
     * @return \StructType\Field|null
     */
    public function getOverrideContact()
    {
        return $this->OverrideContact;
    }
    /**
     * Set OverrideContact value
     * @param \StructType\Field $overrideContact
     * @return \StructType\ShippingSettingsShipToContact
     */
    public function setOverrideContact(\StructType\Field $overrideContact = null)
    {
        $this->OverrideContact = $overrideContact;
        return $this;
    }
    /**
     * Get CompanyName value
     * @return \StructType\Field|null
     */
    public function getCompanyName()
    {
        return $this->CompanyName;
    }
    /**
     * Set CompanyName value
     * @param \StructType\Field $companyName
     * @return \StructType\ShippingSettingsShipToContact
     */
    public function setCompanyName(\StructType\Field $companyName = null)
    {
        $this->CompanyName = $companyName;
        return $this;
    }
    /**
     * Get Attention value
     * @return \StructType\Field|null
     */
    public function getAttention()
    {
        return $this->Attention;
    }
    /**
     * Set Attention value
     * @param \StructType\Field $attention
     * @return \StructType\ShippingSettingsShipToContact
     */
    public function setAttention(\StructType\Field $attention = null)
    {
        $this->Attention = $attention;
        return $this;
    }
    /**
     * Get Phone1 value
     * @return \StructType\Field|null
     */
    public function getPhone1()
    {
        return $this->Phone1;
    }
    /**
     * Set Phone1 value
     * @param \StructType\Field $phone1
     * @return \StructType\ShippingSettingsShipToContact
     */
    public function setPhone1(\StructType\Field $phone1 = null)
    {
        $this->Phone1 = $phone1;
        return $this;
    }
    /**
     * Get Email value
     * @return \StructType\Field|null
     */
    public function getEmail()
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @param \StructType\Field $email
     * @return \StructType\ShippingSettingsShipToContact
     */
    public function setEmail(\StructType\Field $email = null)
    {
        $this->Email = $email;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\ShippingSettingsShipToContactServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\ShippingSettingsShipToContactServiceCommands $serviceCommands
     * @return \StructType\ShippingSettingsShipToContact
     */
    public function setServiceCommands(\StructType\ShippingSettingsShipToContactServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ShippingSettingsShipToContact
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
