<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TaxDetails StructType
 * @subpackage Structs
 */
class TaxDetails extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The TaxID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TaxID;
    /**
     * The TaxRate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TaxRate;
    /**
     * The TaxableAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TaxableAmount;
    /**
     * The ExemptedAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ExemptedAmount;
    /**
     * The TaxUOM
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TaxUOM;
    /**
     * The TaxableQty
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TaxableQty;
    /**
     * The TaxAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TaxAmount;
    /**
     * The TaxType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $TaxType;
    /**
     * The PendingVAT
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PendingVAT;
    /**
     * The ReverseVAT
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $ReverseVAT;
    /**
     * The IncludeInVATExemptTotal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $IncludeInVATExemptTotal;
    /**
     * The StatisticalVAT
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $StatisticalVAT;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\TaxDetailsServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for TaxDetails
     * @uses TaxDetails::setDisplayName()
     * @uses TaxDetails::setTaxID()
     * @uses TaxDetails::setTaxRate()
     * @uses TaxDetails::setTaxableAmount()
     * @uses TaxDetails::setExemptedAmount()
     * @uses TaxDetails::setTaxUOM()
     * @uses TaxDetails::setTaxableQty()
     * @uses TaxDetails::setTaxAmount()
     * @uses TaxDetails::setTaxType()
     * @uses TaxDetails::setPendingVAT()
     * @uses TaxDetails::setReverseVAT()
     * @uses TaxDetails::setIncludeInVATExemptTotal()
     * @uses TaxDetails::setStatisticalVAT()
     * @uses TaxDetails::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $taxID
     * @param \StructType\Field $taxRate
     * @param \StructType\Field $taxableAmount
     * @param \StructType\Field $exemptedAmount
     * @param \StructType\Field $taxUOM
     * @param \StructType\Field $taxableQty
     * @param \StructType\Field $taxAmount
     * @param \StructType\Field $taxType
     * @param \StructType\Field $pendingVAT
     * @param \StructType\Field $reverseVAT
     * @param \StructType\Field $includeInVATExemptTotal
     * @param \StructType\Field $statisticalVAT
     * @param \StructType\TaxDetailsServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $taxID = null, \StructType\Field $taxRate = null, \StructType\Field $taxableAmount = null, \StructType\Field $exemptedAmount = null, \StructType\Field $taxUOM = null, \StructType\Field $taxableQty = null, \StructType\Field $taxAmount = null, \StructType\Field $taxType = null, \StructType\Field $pendingVAT = null, \StructType\Field $reverseVAT = null, \StructType\Field $includeInVATExemptTotal = null, \StructType\Field $statisticalVAT = null, \StructType\TaxDetailsServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setTaxID($taxID)
            ->setTaxRate($taxRate)
            ->setTaxableAmount($taxableAmount)
            ->setExemptedAmount($exemptedAmount)
            ->setTaxUOM($taxUOM)
            ->setTaxableQty($taxableQty)
            ->setTaxAmount($taxAmount)
            ->setTaxType($taxType)
            ->setPendingVAT($pendingVAT)
            ->setReverseVAT($reverseVAT)
            ->setIncludeInVATExemptTotal($includeInVATExemptTotal)
            ->setStatisticalVAT($statisticalVAT)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\TaxDetails
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get TaxID value
     * @return \StructType\Field|null
     */
    public function getTaxID()
    {
        return $this->TaxID;
    }
    /**
     * Set TaxID value
     * @param \StructType\Field $taxID
     * @return \StructType\TaxDetails
     */
    public function setTaxID(\StructType\Field $taxID = null)
    {
        $this->TaxID = $taxID;
        return $this;
    }
    /**
     * Get TaxRate value
     * @return \StructType\Field|null
     */
    public function getTaxRate()
    {
        return $this->TaxRate;
    }
    /**
     * Set TaxRate value
     * @param \StructType\Field $taxRate
     * @return \StructType\TaxDetails
     */
    public function setTaxRate(\StructType\Field $taxRate = null)
    {
        $this->TaxRate = $taxRate;
        return $this;
    }
    /**
     * Get TaxableAmount value
     * @return \StructType\Field|null
     */
    public function getTaxableAmount()
    {
        return $this->TaxableAmount;
    }
    /**
     * Set TaxableAmount value
     * @param \StructType\Field $taxableAmount
     * @return \StructType\TaxDetails
     */
    public function setTaxableAmount(\StructType\Field $taxableAmount = null)
    {
        $this->TaxableAmount = $taxableAmount;
        return $this;
    }
    /**
     * Get ExemptedAmount value
     * @return \StructType\Field|null
     */
    public function getExemptedAmount()
    {
        return $this->ExemptedAmount;
    }
    /**
     * Set ExemptedAmount value
     * @param \StructType\Field $exemptedAmount
     * @return \StructType\TaxDetails
     */
    public function setExemptedAmount(\StructType\Field $exemptedAmount = null)
    {
        $this->ExemptedAmount = $exemptedAmount;
        return $this;
    }
    /**
     * Get TaxUOM value
     * @return \StructType\Field|null
     */
    public function getTaxUOM()
    {
        return $this->TaxUOM;
    }
    /**
     * Set TaxUOM value
     * @param \StructType\Field $taxUOM
     * @return \StructType\TaxDetails
     */
    public function setTaxUOM(\StructType\Field $taxUOM = null)
    {
        $this->TaxUOM = $taxUOM;
        return $this;
    }
    /**
     * Get TaxableQty value
     * @return \StructType\Field|null
     */
    public function getTaxableQty()
    {
        return $this->TaxableQty;
    }
    /**
     * Set TaxableQty value
     * @param \StructType\Field $taxableQty
     * @return \StructType\TaxDetails
     */
    public function setTaxableQty(\StructType\Field $taxableQty = null)
    {
        $this->TaxableQty = $taxableQty;
        return $this;
    }
    /**
     * Get TaxAmount value
     * @return \StructType\Field|null
     */
    public function getTaxAmount()
    {
        return $this->TaxAmount;
    }
    /**
     * Set TaxAmount value
     * @param \StructType\Field $taxAmount
     * @return \StructType\TaxDetails
     */
    public function setTaxAmount(\StructType\Field $taxAmount = null)
    {
        $this->TaxAmount = $taxAmount;
        return $this;
    }
    /**
     * Get TaxType value
     * @return \StructType\Field|null
     */
    public function getTaxType()
    {
        return $this->TaxType;
    }
    /**
     * Set TaxType value
     * @param \StructType\Field $taxType
     * @return \StructType\TaxDetails
     */
    public function setTaxType(\StructType\Field $taxType = null)
    {
        $this->TaxType = $taxType;
        return $this;
    }
    /**
     * Get PendingVAT value
     * @return \StructType\Field|null
     */
    public function getPendingVAT()
    {
        return $this->PendingVAT;
    }
    /**
     * Set PendingVAT value
     * @param \StructType\Field $pendingVAT
     * @return \StructType\TaxDetails
     */
    public function setPendingVAT(\StructType\Field $pendingVAT = null)
    {
        $this->PendingVAT = $pendingVAT;
        return $this;
    }
    /**
     * Get ReverseVAT value
     * @return \StructType\Field|null
     */
    public function getReverseVAT()
    {
        return $this->ReverseVAT;
    }
    /**
     * Set ReverseVAT value
     * @param \StructType\Field $reverseVAT
     * @return \StructType\TaxDetails
     */
    public function setReverseVAT(\StructType\Field $reverseVAT = null)
    {
        $this->ReverseVAT = $reverseVAT;
        return $this;
    }
    /**
     * Get IncludeInVATExemptTotal value
     * @return \StructType\Field|null
     */
    public function getIncludeInVATExemptTotal()
    {
        return $this->IncludeInVATExemptTotal;
    }
    /**
     * Set IncludeInVATExemptTotal value
     * @param \StructType\Field $includeInVATExemptTotal
     * @return \StructType\TaxDetails
     */
    public function setIncludeInVATExemptTotal(\StructType\Field $includeInVATExemptTotal = null)
    {
        $this->IncludeInVATExemptTotal = $includeInVATExemptTotal;
        return $this;
    }
    /**
     * Get StatisticalVAT value
     * @return \StructType\Field|null
     */
    public function getStatisticalVAT()
    {
        return $this->StatisticalVAT;
    }
    /**
     * Set StatisticalVAT value
     * @param \StructType\Field $statisticalVAT
     * @return \StructType\TaxDetails
     */
    public function setStatisticalVAT(\StructType\Field $statisticalVAT = null)
    {
        $this->StatisticalVAT = $statisticalVAT;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\TaxDetailsServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\TaxDetailsServiceCommands $serviceCommands
     * @return \StructType\TaxDetails
     */
    public function setServiceCommands(\StructType\TaxDetailsServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TaxDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
