<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TotalsCalculatedAmountsAndQuantities StructType
 * @subpackage Structs
 */
class TotalsCalculatedAmountsAndQuantities extends AbstractStructBase
{
    /**
     * The DisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DisplayName;
    /**
     * The UnshippedQuantity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UnshippedQuantity;
    /**
     * The UnshippedAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UnshippedAmount;
    /**
     * The UnbilledQuantity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UnbilledQuantity;
    /**
     * The UnbilledAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UnbilledAmount;
    /**
     * The PaymentTotal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PaymentTotal;
    /**
     * The PreAuthorizedAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $PreAuthorizedAmount;
    /**
     * The UnpaidBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Field
     */
    public $UnpaidBalance;
    /**
     * The ServiceCommands
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\TotalsCalculatedAmountsAndQuantitiesServiceCommands
     */
    public $ServiceCommands;
    /**
     * Constructor method for TotalsCalculatedAmountsAndQuantities
     * @uses TotalsCalculatedAmountsAndQuantities::setDisplayName()
     * @uses TotalsCalculatedAmountsAndQuantities::setUnshippedQuantity()
     * @uses TotalsCalculatedAmountsAndQuantities::setUnshippedAmount()
     * @uses TotalsCalculatedAmountsAndQuantities::setUnbilledQuantity()
     * @uses TotalsCalculatedAmountsAndQuantities::setUnbilledAmount()
     * @uses TotalsCalculatedAmountsAndQuantities::setPaymentTotal()
     * @uses TotalsCalculatedAmountsAndQuantities::setPreAuthorizedAmount()
     * @uses TotalsCalculatedAmountsAndQuantities::setUnpaidBalance()
     * @uses TotalsCalculatedAmountsAndQuantities::setServiceCommands()
     * @param string $displayName
     * @param \StructType\Field $unshippedQuantity
     * @param \StructType\Field $unshippedAmount
     * @param \StructType\Field $unbilledQuantity
     * @param \StructType\Field $unbilledAmount
     * @param \StructType\Field $paymentTotal
     * @param \StructType\Field $preAuthorizedAmount
     * @param \StructType\Field $unpaidBalance
     * @param \StructType\TotalsCalculatedAmountsAndQuantitiesServiceCommands $serviceCommands
     */
    public function __construct($displayName = null, \StructType\Field $unshippedQuantity = null, \StructType\Field $unshippedAmount = null, \StructType\Field $unbilledQuantity = null, \StructType\Field $unbilledAmount = null, \StructType\Field $paymentTotal = null, \StructType\Field $preAuthorizedAmount = null, \StructType\Field $unpaidBalance = null, \StructType\TotalsCalculatedAmountsAndQuantitiesServiceCommands $serviceCommands = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setUnshippedQuantity($unshippedQuantity)
            ->setUnshippedAmount($unshippedAmount)
            ->setUnbilledQuantity($unbilledQuantity)
            ->setUnbilledAmount($unbilledAmount)
            ->setPaymentTotal($paymentTotal)
            ->setPreAuthorizedAmount($preAuthorizedAmount)
            ->setUnpaidBalance($unpaidBalance)
            ->setServiceCommands($serviceCommands);
    }
    /**
     * Get DisplayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->DisplayName;
    }
    /**
     * Set DisplayName value
     * @param string $displayName
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($displayName, true), gettype($displayName)), __LINE__);
        }
        $this->DisplayName = $displayName;
        return $this;
    }
    /**
     * Get UnshippedQuantity value
     * @return \StructType\Field|null
     */
    public function getUnshippedQuantity()
    {
        return $this->UnshippedQuantity;
    }
    /**
     * Set UnshippedQuantity value
     * @param \StructType\Field $unshippedQuantity
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setUnshippedQuantity(\StructType\Field $unshippedQuantity = null)
    {
        $this->UnshippedQuantity = $unshippedQuantity;
        return $this;
    }
    /**
     * Get UnshippedAmount value
     * @return \StructType\Field|null
     */
    public function getUnshippedAmount()
    {
        return $this->UnshippedAmount;
    }
    /**
     * Set UnshippedAmount value
     * @param \StructType\Field $unshippedAmount
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setUnshippedAmount(\StructType\Field $unshippedAmount = null)
    {
        $this->UnshippedAmount = $unshippedAmount;
        return $this;
    }
    /**
     * Get UnbilledQuantity value
     * @return \StructType\Field|null
     */
    public function getUnbilledQuantity()
    {
        return $this->UnbilledQuantity;
    }
    /**
     * Set UnbilledQuantity value
     * @param \StructType\Field $unbilledQuantity
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setUnbilledQuantity(\StructType\Field $unbilledQuantity = null)
    {
        $this->UnbilledQuantity = $unbilledQuantity;
        return $this;
    }
    /**
     * Get UnbilledAmount value
     * @return \StructType\Field|null
     */
    public function getUnbilledAmount()
    {
        return $this->UnbilledAmount;
    }
    /**
     * Set UnbilledAmount value
     * @param \StructType\Field $unbilledAmount
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setUnbilledAmount(\StructType\Field $unbilledAmount = null)
    {
        $this->UnbilledAmount = $unbilledAmount;
        return $this;
    }
    /**
     * Get PaymentTotal value
     * @return \StructType\Field|null
     */
    public function getPaymentTotal()
    {
        return $this->PaymentTotal;
    }
    /**
     * Set PaymentTotal value
     * @param \StructType\Field $paymentTotal
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setPaymentTotal(\StructType\Field $paymentTotal = null)
    {
        $this->PaymentTotal = $paymentTotal;
        return $this;
    }
    /**
     * Get PreAuthorizedAmount value
     * @return \StructType\Field|null
     */
    public function getPreAuthorizedAmount()
    {
        return $this->PreAuthorizedAmount;
    }
    /**
     * Set PreAuthorizedAmount value
     * @param \StructType\Field $preAuthorizedAmount
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setPreAuthorizedAmount(\StructType\Field $preAuthorizedAmount = null)
    {
        $this->PreAuthorizedAmount = $preAuthorizedAmount;
        return $this;
    }
    /**
     * Get UnpaidBalance value
     * @return \StructType\Field|null
     */
    public function getUnpaidBalance()
    {
        return $this->UnpaidBalance;
    }
    /**
     * Set UnpaidBalance value
     * @param \StructType\Field $unpaidBalance
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setUnpaidBalance(\StructType\Field $unpaidBalance = null)
    {
        $this->UnpaidBalance = $unpaidBalance;
        return $this;
    }
    /**
     * Get ServiceCommands value
     * @return \StructType\TotalsCalculatedAmountsAndQuantitiesServiceCommands|null
     */
    public function getServiceCommands()
    {
        return $this->ServiceCommands;
    }
    /**
     * Set ServiceCommands value
     * @param \StructType\TotalsCalculatedAmountsAndQuantitiesServiceCommands $serviceCommands
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public function setServiceCommands(\StructType\TotalsCalculatedAmountsAndQuantitiesServiceCommands $serviceCommands = null)
    {
        $this->ServiceCommands = $serviceCommands;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TotalsCalculatedAmountsAndQuantities
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
